package com.bweb.excel.model;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @className: exportTradeOrderModel
 * @author: HuRui
 * @date: 2023/3/30
 **/
@Data
public class ExportTradeOrderModel {

    @ColumnWidth(25)
    @ExcelProperty(value = "商户名称")
    private String merName;

    @ColumnWidth(25)
    @ExcelProperty(value = "门店名称")
    private String storeName;

    @ColumnWidth(30)
    @ExcelProperty(value = "交易单号")
    private String outTradeNo;

    @ColumnWidth(25)
    @ExcelProperty(value = "支付方式")
    private String payMode;

    @ColumnWidth(25)
    @ExcelProperty(value = "交易金额")
    private BigDecimal tradeAmount;

    @ColumnWidth(25)
    @ExcelProperty(value = "门店优惠")
    private BigDecimal storeDiscountActualPrice;

    @ColumnWidth(25)
    @ExcelProperty(value = "优惠券优惠")
    private BigDecimal userDiscountActualPrice;

    @ColumnWidth(25)
    @ExcelProperty(value = "实付金额")
    private BigDecimal tradeActualAmount;

    @ColumnWidth(20)
    @ExcelProperty(value = "交易状态")
    private String status;

    @ColumnWidth(25)
    @ExcelProperty(value = "创建时间")
    private Date createTime;

    @ColumnWidth(25)
    @ExcelProperty(value = "支付时间")
    private Date payTime;

    @ColumnWidth(25)
    @ExcelProperty(value = "入账商户号")
    private String platformMerNo;

    @ColumnWidth(25)
    @ExcelProperty(value = "业务员")
    private String salesmanName;

}
