package com.hfkj.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class BsTradeOrderExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public BsTradeOrderExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNull() {
            addCriterion("company_id is null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNotNull() {
            addCriterion("company_id is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdEqualTo(Long value) {
            addCriterion("company_id =", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotEqualTo(Long value) {
            addCriterion("company_id <>", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThan(Long value) {
            addCriterion("company_id >", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThanOrEqualTo(Long value) {
            addCriterion("company_id >=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThan(Long value) {
            addCriterion("company_id <", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThanOrEqualTo(Long value) {
            addCriterion("company_id <=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIn(List<Long> values) {
            addCriterion("company_id in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotIn(List<Long> values) {
            addCriterion("company_id not in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdBetween(Long value1, Long value2) {
            addCriterion("company_id between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotBetween(Long value1, Long value2) {
            addCriterion("company_id not between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andAgentIdIsNull() {
            addCriterion("agent_id is null");
            return (Criteria) this;
        }

        public Criteria andAgentIdIsNotNull() {
            addCriterion("agent_id is not null");
            return (Criteria) this;
        }

        public Criteria andAgentIdEqualTo(Long value) {
            addCriterion("agent_id =", value, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdNotEqualTo(Long value) {
            addCriterion("agent_id <>", value, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdGreaterThan(Long value) {
            addCriterion("agent_id >", value, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdGreaterThanOrEqualTo(Long value) {
            addCriterion("agent_id >=", value, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdLessThan(Long value) {
            addCriterion("agent_id <", value, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdLessThanOrEqualTo(Long value) {
            addCriterion("agent_id <=", value, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdIn(List<Long> values) {
            addCriterion("agent_id in", values, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdNotIn(List<Long> values) {
            addCriterion("agent_id not in", values, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdBetween(Long value1, Long value2) {
            addCriterion("agent_id between", value1, value2, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdNotBetween(Long value1, Long value2) {
            addCriterion("agent_id not between", value1, value2, "agentId");
            return (Criteria) this;
        }

        public Criteria andSalesmanIdIsNull() {
            addCriterion("salesman_id is null");
            return (Criteria) this;
        }

        public Criteria andSalesmanIdIsNotNull() {
            addCriterion("salesman_id is not null");
            return (Criteria) this;
        }

        public Criteria andSalesmanIdEqualTo(Long value) {
            addCriterion("salesman_id =", value, "salesmanId");
            return (Criteria) this;
        }

        public Criteria andSalesmanIdNotEqualTo(Long value) {
            addCriterion("salesman_id <>", value, "salesmanId");
            return (Criteria) this;
        }

        public Criteria andSalesmanIdGreaterThan(Long value) {
            addCriterion("salesman_id >", value, "salesmanId");
            return (Criteria) this;
        }

        public Criteria andSalesmanIdGreaterThanOrEqualTo(Long value) {
            addCriterion("salesman_id >=", value, "salesmanId");
            return (Criteria) this;
        }

        public Criteria andSalesmanIdLessThan(Long value) {
            addCriterion("salesman_id <", value, "salesmanId");
            return (Criteria) this;
        }

        public Criteria andSalesmanIdLessThanOrEqualTo(Long value) {
            addCriterion("salesman_id <=", value, "salesmanId");
            return (Criteria) this;
        }

        public Criteria andSalesmanIdIn(List<Long> values) {
            addCriterion("salesman_id in", values, "salesmanId");
            return (Criteria) this;
        }

        public Criteria andSalesmanIdNotIn(List<Long> values) {
            addCriterion("salesman_id not in", values, "salesmanId");
            return (Criteria) this;
        }

        public Criteria andSalesmanIdBetween(Long value1, Long value2) {
            addCriterion("salesman_id between", value1, value2, "salesmanId");
            return (Criteria) this;
        }

        public Criteria andSalesmanIdNotBetween(Long value1, Long value2) {
            addCriterion("salesman_id not between", value1, value2, "salesmanId");
            return (Criteria) this;
        }

        public Criteria andSalesmanNameIsNull() {
            addCriterion("salesman_name is null");
            return (Criteria) this;
        }

        public Criteria andSalesmanNameIsNotNull() {
            addCriterion("salesman_name is not null");
            return (Criteria) this;
        }

        public Criteria andSalesmanNameEqualTo(String value) {
            addCriterion("salesman_name =", value, "salesmanName");
            return (Criteria) this;
        }

        public Criteria andSalesmanNameNotEqualTo(String value) {
            addCriterion("salesman_name <>", value, "salesmanName");
            return (Criteria) this;
        }

        public Criteria andSalesmanNameGreaterThan(String value) {
            addCriterion("salesman_name >", value, "salesmanName");
            return (Criteria) this;
        }

        public Criteria andSalesmanNameGreaterThanOrEqualTo(String value) {
            addCriterion("salesman_name >=", value, "salesmanName");
            return (Criteria) this;
        }

        public Criteria andSalesmanNameLessThan(String value) {
            addCriterion("salesman_name <", value, "salesmanName");
            return (Criteria) this;
        }

        public Criteria andSalesmanNameLessThanOrEqualTo(String value) {
            addCriterion("salesman_name <=", value, "salesmanName");
            return (Criteria) this;
        }

        public Criteria andSalesmanNameLike(String value) {
            addCriterion("salesman_name like", value, "salesmanName");
            return (Criteria) this;
        }

        public Criteria andSalesmanNameNotLike(String value) {
            addCriterion("salesman_name not like", value, "salesmanName");
            return (Criteria) this;
        }

        public Criteria andSalesmanNameIn(List<String> values) {
            addCriterion("salesman_name in", values, "salesmanName");
            return (Criteria) this;
        }

        public Criteria andSalesmanNameNotIn(List<String> values) {
            addCriterion("salesman_name not in", values, "salesmanName");
            return (Criteria) this;
        }

        public Criteria andSalesmanNameBetween(String value1, String value2) {
            addCriterion("salesman_name between", value1, value2, "salesmanName");
            return (Criteria) this;
        }

        public Criteria andSalesmanNameNotBetween(String value1, String value2) {
            addCriterion("salesman_name not between", value1, value2, "salesmanName");
            return (Criteria) this;
        }

        public Criteria andMerIdIsNull() {
            addCriterion("mer_id is null");
            return (Criteria) this;
        }

        public Criteria andMerIdIsNotNull() {
            addCriterion("mer_id is not null");
            return (Criteria) this;
        }

        public Criteria andMerIdEqualTo(Long value) {
            addCriterion("mer_id =", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdNotEqualTo(Long value) {
            addCriterion("mer_id <>", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdGreaterThan(Long value) {
            addCriterion("mer_id >", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdGreaterThanOrEqualTo(Long value) {
            addCriterion("mer_id >=", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdLessThan(Long value) {
            addCriterion("mer_id <", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdLessThanOrEqualTo(Long value) {
            addCriterion("mer_id <=", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdIn(List<Long> values) {
            addCriterion("mer_id in", values, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdNotIn(List<Long> values) {
            addCriterion("mer_id not in", values, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdBetween(Long value1, Long value2) {
            addCriterion("mer_id between", value1, value2, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdNotBetween(Long value1, Long value2) {
            addCriterion("mer_id not between", value1, value2, "merId");
            return (Criteria) this;
        }

        public Criteria andMerNameIsNull() {
            addCriterion("mer_name is null");
            return (Criteria) this;
        }

        public Criteria andMerNameIsNotNull() {
            addCriterion("mer_name is not null");
            return (Criteria) this;
        }

        public Criteria andMerNameEqualTo(String value) {
            addCriterion("mer_name =", value, "merName");
            return (Criteria) this;
        }

        public Criteria andMerNameNotEqualTo(String value) {
            addCriterion("mer_name <>", value, "merName");
            return (Criteria) this;
        }

        public Criteria andMerNameGreaterThan(String value) {
            addCriterion("mer_name >", value, "merName");
            return (Criteria) this;
        }

        public Criteria andMerNameGreaterThanOrEqualTo(String value) {
            addCriterion("mer_name >=", value, "merName");
            return (Criteria) this;
        }

        public Criteria andMerNameLessThan(String value) {
            addCriterion("mer_name <", value, "merName");
            return (Criteria) this;
        }

        public Criteria andMerNameLessThanOrEqualTo(String value) {
            addCriterion("mer_name <=", value, "merName");
            return (Criteria) this;
        }

        public Criteria andMerNameLike(String value) {
            addCriterion("mer_name like", value, "merName");
            return (Criteria) this;
        }

        public Criteria andMerNameNotLike(String value) {
            addCriterion("mer_name not like", value, "merName");
            return (Criteria) this;
        }

        public Criteria andMerNameIn(List<String> values) {
            addCriterion("mer_name in", values, "merName");
            return (Criteria) this;
        }

        public Criteria andMerNameNotIn(List<String> values) {
            addCriterion("mer_name not in", values, "merName");
            return (Criteria) this;
        }

        public Criteria andMerNameBetween(String value1, String value2) {
            addCriterion("mer_name between", value1, value2, "merName");
            return (Criteria) this;
        }

        public Criteria andMerNameNotBetween(String value1, String value2) {
            addCriterion("mer_name not between", value1, value2, "merName");
            return (Criteria) this;
        }

        public Criteria andMerNoIsNull() {
            addCriterion("mer_no is null");
            return (Criteria) this;
        }

        public Criteria andMerNoIsNotNull() {
            addCriterion("mer_no is not null");
            return (Criteria) this;
        }

        public Criteria andMerNoEqualTo(String value) {
            addCriterion("mer_no =", value, "merNo");
            return (Criteria) this;
        }

        public Criteria andMerNoNotEqualTo(String value) {
            addCriterion("mer_no <>", value, "merNo");
            return (Criteria) this;
        }

        public Criteria andMerNoGreaterThan(String value) {
            addCriterion("mer_no >", value, "merNo");
            return (Criteria) this;
        }

        public Criteria andMerNoGreaterThanOrEqualTo(String value) {
            addCriterion("mer_no >=", value, "merNo");
            return (Criteria) this;
        }

        public Criteria andMerNoLessThan(String value) {
            addCriterion("mer_no <", value, "merNo");
            return (Criteria) this;
        }

        public Criteria andMerNoLessThanOrEqualTo(String value) {
            addCriterion("mer_no <=", value, "merNo");
            return (Criteria) this;
        }

        public Criteria andMerNoLike(String value) {
            addCriterion("mer_no like", value, "merNo");
            return (Criteria) this;
        }

        public Criteria andMerNoNotLike(String value) {
            addCriterion("mer_no not like", value, "merNo");
            return (Criteria) this;
        }

        public Criteria andMerNoIn(List<String> values) {
            addCriterion("mer_no in", values, "merNo");
            return (Criteria) this;
        }

        public Criteria andMerNoNotIn(List<String> values) {
            addCriterion("mer_no not in", values, "merNo");
            return (Criteria) this;
        }

        public Criteria andMerNoBetween(String value1, String value2) {
            addCriterion("mer_no between", value1, value2, "merNo");
            return (Criteria) this;
        }

        public Criteria andMerNoNotBetween(String value1, String value2) {
            addCriterion("mer_no not between", value1, value2, "merNo");
            return (Criteria) this;
        }

        public Criteria andStoreIdIsNull() {
            addCriterion("store_id is null");
            return (Criteria) this;
        }

        public Criteria andStoreIdIsNotNull() {
            addCriterion("store_id is not null");
            return (Criteria) this;
        }

        public Criteria andStoreIdEqualTo(Long value) {
            addCriterion("store_id =", value, "storeId");
            return (Criteria) this;
        }

        public Criteria andStoreIdNotEqualTo(Long value) {
            addCriterion("store_id <>", value, "storeId");
            return (Criteria) this;
        }

        public Criteria andStoreIdGreaterThan(Long value) {
            addCriterion("store_id >", value, "storeId");
            return (Criteria) this;
        }

        public Criteria andStoreIdGreaterThanOrEqualTo(Long value) {
            addCriterion("store_id >=", value, "storeId");
            return (Criteria) this;
        }

        public Criteria andStoreIdLessThan(Long value) {
            addCriterion("store_id <", value, "storeId");
            return (Criteria) this;
        }

        public Criteria andStoreIdLessThanOrEqualTo(Long value) {
            addCriterion("store_id <=", value, "storeId");
            return (Criteria) this;
        }

        public Criteria andStoreIdIn(List<Long> values) {
            addCriterion("store_id in", values, "storeId");
            return (Criteria) this;
        }

        public Criteria andStoreIdNotIn(List<Long> values) {
            addCriterion("store_id not in", values, "storeId");
            return (Criteria) this;
        }

        public Criteria andStoreIdBetween(Long value1, Long value2) {
            addCriterion("store_id between", value1, value2, "storeId");
            return (Criteria) this;
        }

        public Criteria andStoreIdNotBetween(Long value1, Long value2) {
            addCriterion("store_id not between", value1, value2, "storeId");
            return (Criteria) this;
        }

        public Criteria andStoreNameIsNull() {
            addCriterion("store_name is null");
            return (Criteria) this;
        }

        public Criteria andStoreNameIsNotNull() {
            addCriterion("store_name is not null");
            return (Criteria) this;
        }

        public Criteria andStoreNameEqualTo(String value) {
            addCriterion("store_name =", value, "storeName");
            return (Criteria) this;
        }

        public Criteria andStoreNameNotEqualTo(String value) {
            addCriterion("store_name <>", value, "storeName");
            return (Criteria) this;
        }

        public Criteria andStoreNameGreaterThan(String value) {
            addCriterion("store_name >", value, "storeName");
            return (Criteria) this;
        }

        public Criteria andStoreNameGreaterThanOrEqualTo(String value) {
            addCriterion("store_name >=", value, "storeName");
            return (Criteria) this;
        }

        public Criteria andStoreNameLessThan(String value) {
            addCriterion("store_name <", value, "storeName");
            return (Criteria) this;
        }

        public Criteria andStoreNameLessThanOrEqualTo(String value) {
            addCriterion("store_name <=", value, "storeName");
            return (Criteria) this;
        }

        public Criteria andStoreNameLike(String value) {
            addCriterion("store_name like", value, "storeName");
            return (Criteria) this;
        }

        public Criteria andStoreNameNotLike(String value) {
            addCriterion("store_name not like", value, "storeName");
            return (Criteria) this;
        }

        public Criteria andStoreNameIn(List<String> values) {
            addCriterion("store_name in", values, "storeName");
            return (Criteria) this;
        }

        public Criteria andStoreNameNotIn(List<String> values) {
            addCriterion("store_name not in", values, "storeName");
            return (Criteria) this;
        }

        public Criteria andStoreNameBetween(String value1, String value2) {
            addCriterion("store_name between", value1, value2, "storeName");
            return (Criteria) this;
        }

        public Criteria andStoreNameNotBetween(String value1, String value2) {
            addCriterion("store_name not between", value1, value2, "storeName");
            return (Criteria) this;
        }

        public Criteria andDeviceIdIsNull() {
            addCriterion("device_id is null");
            return (Criteria) this;
        }

        public Criteria andDeviceIdIsNotNull() {
            addCriterion("device_id is not null");
            return (Criteria) this;
        }

        public Criteria andDeviceIdEqualTo(Long value) {
            addCriterion("device_id =", value, "deviceId");
            return (Criteria) this;
        }

        public Criteria andDeviceIdNotEqualTo(Long value) {
            addCriterion("device_id <>", value, "deviceId");
            return (Criteria) this;
        }

        public Criteria andDeviceIdGreaterThan(Long value) {
            addCriterion("device_id >", value, "deviceId");
            return (Criteria) this;
        }

        public Criteria andDeviceIdGreaterThanOrEqualTo(Long value) {
            addCriterion("device_id >=", value, "deviceId");
            return (Criteria) this;
        }

        public Criteria andDeviceIdLessThan(Long value) {
            addCriterion("device_id <", value, "deviceId");
            return (Criteria) this;
        }

        public Criteria andDeviceIdLessThanOrEqualTo(Long value) {
            addCriterion("device_id <=", value, "deviceId");
            return (Criteria) this;
        }

        public Criteria andDeviceIdIn(List<Long> values) {
            addCriterion("device_id in", values, "deviceId");
            return (Criteria) this;
        }

        public Criteria andDeviceIdNotIn(List<Long> values) {
            addCriterion("device_id not in", values, "deviceId");
            return (Criteria) this;
        }

        public Criteria andDeviceIdBetween(Long value1, Long value2) {
            addCriterion("device_id between", value1, value2, "deviceId");
            return (Criteria) this;
        }

        public Criteria andDeviceIdNotBetween(Long value1, Long value2) {
            addCriterion("device_id not between", value1, value2, "deviceId");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIsNull() {
            addCriterion("device_sn is null");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIsNotNull() {
            addCriterion("device_sn is not null");
            return (Criteria) this;
        }

        public Criteria andDeviceSnEqualTo(String value) {
            addCriterion("device_sn =", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotEqualTo(String value) {
            addCriterion("device_sn <>", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnGreaterThan(String value) {
            addCriterion("device_sn >", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnGreaterThanOrEqualTo(String value) {
            addCriterion("device_sn >=", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLessThan(String value) {
            addCriterion("device_sn <", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLessThanOrEqualTo(String value) {
            addCriterion("device_sn <=", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLike(String value) {
            addCriterion("device_sn like", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotLike(String value) {
            addCriterion("device_sn not like", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIn(List<String> values) {
            addCriterion("device_sn in", values, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotIn(List<String> values) {
            addCriterion("device_sn not in", values, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnBetween(String value1, String value2) {
            addCriterion("device_sn between", value1, value2, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotBetween(String value1, String value2) {
            addCriterion("device_sn not between", value1, value2, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andQrCodeIdIsNull() {
            addCriterion("qr_code_id is null");
            return (Criteria) this;
        }

        public Criteria andQrCodeIdIsNotNull() {
            addCriterion("qr_code_id is not null");
            return (Criteria) this;
        }

        public Criteria andQrCodeIdEqualTo(Long value) {
            addCriterion("qr_code_id =", value, "qrCodeId");
            return (Criteria) this;
        }

        public Criteria andQrCodeIdNotEqualTo(Long value) {
            addCriterion("qr_code_id <>", value, "qrCodeId");
            return (Criteria) this;
        }

        public Criteria andQrCodeIdGreaterThan(Long value) {
            addCriterion("qr_code_id >", value, "qrCodeId");
            return (Criteria) this;
        }

        public Criteria andQrCodeIdGreaterThanOrEqualTo(Long value) {
            addCriterion("qr_code_id >=", value, "qrCodeId");
            return (Criteria) this;
        }

        public Criteria andQrCodeIdLessThan(Long value) {
            addCriterion("qr_code_id <", value, "qrCodeId");
            return (Criteria) this;
        }

        public Criteria andQrCodeIdLessThanOrEqualTo(Long value) {
            addCriterion("qr_code_id <=", value, "qrCodeId");
            return (Criteria) this;
        }

        public Criteria andQrCodeIdIn(List<Long> values) {
            addCriterion("qr_code_id in", values, "qrCodeId");
            return (Criteria) this;
        }

        public Criteria andQrCodeIdNotIn(List<Long> values) {
            addCriterion("qr_code_id not in", values, "qrCodeId");
            return (Criteria) this;
        }

        public Criteria andQrCodeIdBetween(Long value1, Long value2) {
            addCriterion("qr_code_id between", value1, value2, "qrCodeId");
            return (Criteria) this;
        }

        public Criteria andQrCodeIdNotBetween(Long value1, Long value2) {
            addCriterion("qr_code_id not between", value1, value2, "qrCodeId");
            return (Criteria) this;
        }

        public Criteria andQrCodeSnIsNull() {
            addCriterion("qr_code_sn is null");
            return (Criteria) this;
        }

        public Criteria andQrCodeSnIsNotNull() {
            addCriterion("qr_code_sn is not null");
            return (Criteria) this;
        }

        public Criteria andQrCodeSnEqualTo(String value) {
            addCriterion("qr_code_sn =", value, "qrCodeSn");
            return (Criteria) this;
        }

        public Criteria andQrCodeSnNotEqualTo(String value) {
            addCriterion("qr_code_sn <>", value, "qrCodeSn");
            return (Criteria) this;
        }

        public Criteria andQrCodeSnGreaterThan(String value) {
            addCriterion("qr_code_sn >", value, "qrCodeSn");
            return (Criteria) this;
        }

        public Criteria andQrCodeSnGreaterThanOrEqualTo(String value) {
            addCriterion("qr_code_sn >=", value, "qrCodeSn");
            return (Criteria) this;
        }

        public Criteria andQrCodeSnLessThan(String value) {
            addCriterion("qr_code_sn <", value, "qrCodeSn");
            return (Criteria) this;
        }

        public Criteria andQrCodeSnLessThanOrEqualTo(String value) {
            addCriterion("qr_code_sn <=", value, "qrCodeSn");
            return (Criteria) this;
        }

        public Criteria andQrCodeSnLike(String value) {
            addCriterion("qr_code_sn like", value, "qrCodeSn");
            return (Criteria) this;
        }

        public Criteria andQrCodeSnNotLike(String value) {
            addCriterion("qr_code_sn not like", value, "qrCodeSn");
            return (Criteria) this;
        }

        public Criteria andQrCodeSnIn(List<String> values) {
            addCriterion("qr_code_sn in", values, "qrCodeSn");
            return (Criteria) this;
        }

        public Criteria andQrCodeSnNotIn(List<String> values) {
            addCriterion("qr_code_sn not in", values, "qrCodeSn");
            return (Criteria) this;
        }

        public Criteria andQrCodeSnBetween(String value1, String value2) {
            addCriterion("qr_code_sn between", value1, value2, "qrCodeSn");
            return (Criteria) this;
        }

        public Criteria andQrCodeSnNotBetween(String value1, String value2) {
            addCriterion("qr_code_sn not between", value1, value2, "qrCodeSn");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeIsNull() {
            addCriterion("platform_type is null");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeIsNotNull() {
            addCriterion("platform_type is not null");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeEqualTo(Integer value) {
            addCriterion("platform_type =", value, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeNotEqualTo(Integer value) {
            addCriterion("platform_type <>", value, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeGreaterThan(Integer value) {
            addCriterion("platform_type >", value, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("platform_type >=", value, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeLessThan(Integer value) {
            addCriterion("platform_type <", value, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeLessThanOrEqualTo(Integer value) {
            addCriterion("platform_type <=", value, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeIn(List<Integer> values) {
            addCriterion("platform_type in", values, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeNotIn(List<Integer> values) {
            addCriterion("platform_type not in", values, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeBetween(Integer value1, Integer value2) {
            addCriterion("platform_type between", value1, value2, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("platform_type not between", value1, value2, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformMerNoIsNull() {
            addCriterion("platform_mer_no is null");
            return (Criteria) this;
        }

        public Criteria andPlatformMerNoIsNotNull() {
            addCriterion("platform_mer_no is not null");
            return (Criteria) this;
        }

        public Criteria andPlatformMerNoEqualTo(String value) {
            addCriterion("platform_mer_no =", value, "platformMerNo");
            return (Criteria) this;
        }

        public Criteria andPlatformMerNoNotEqualTo(String value) {
            addCriterion("platform_mer_no <>", value, "platformMerNo");
            return (Criteria) this;
        }

        public Criteria andPlatformMerNoGreaterThan(String value) {
            addCriterion("platform_mer_no >", value, "platformMerNo");
            return (Criteria) this;
        }

        public Criteria andPlatformMerNoGreaterThanOrEqualTo(String value) {
            addCriterion("platform_mer_no >=", value, "platformMerNo");
            return (Criteria) this;
        }

        public Criteria andPlatformMerNoLessThan(String value) {
            addCriterion("platform_mer_no <", value, "platformMerNo");
            return (Criteria) this;
        }

        public Criteria andPlatformMerNoLessThanOrEqualTo(String value) {
            addCriterion("platform_mer_no <=", value, "platformMerNo");
            return (Criteria) this;
        }

        public Criteria andPlatformMerNoLike(String value) {
            addCriterion("platform_mer_no like", value, "platformMerNo");
            return (Criteria) this;
        }

        public Criteria andPlatformMerNoNotLike(String value) {
            addCriterion("platform_mer_no not like", value, "platformMerNo");
            return (Criteria) this;
        }

        public Criteria andPlatformMerNoIn(List<String> values) {
            addCriterion("platform_mer_no in", values, "platformMerNo");
            return (Criteria) this;
        }

        public Criteria andPlatformMerNoNotIn(List<String> values) {
            addCriterion("platform_mer_no not in", values, "platformMerNo");
            return (Criteria) this;
        }

        public Criteria andPlatformMerNoBetween(String value1, String value2) {
            addCriterion("platform_mer_no between", value1, value2, "platformMerNo");
            return (Criteria) this;
        }

        public Criteria andPlatformMerNoNotBetween(String value1, String value2) {
            addCriterion("platform_mer_no not between", value1, value2, "platformMerNo");
            return (Criteria) this;
        }

        public Criteria andPlatformTradeNoIsNull() {
            addCriterion("platform_trade_no is null");
            return (Criteria) this;
        }

        public Criteria andPlatformTradeNoIsNotNull() {
            addCriterion("platform_trade_no is not null");
            return (Criteria) this;
        }

        public Criteria andPlatformTradeNoEqualTo(String value) {
            addCriterion("platform_trade_no =", value, "platformTradeNo");
            return (Criteria) this;
        }

        public Criteria andPlatformTradeNoNotEqualTo(String value) {
            addCriterion("platform_trade_no <>", value, "platformTradeNo");
            return (Criteria) this;
        }

        public Criteria andPlatformTradeNoGreaterThan(String value) {
            addCriterion("platform_trade_no >", value, "platformTradeNo");
            return (Criteria) this;
        }

        public Criteria andPlatformTradeNoGreaterThanOrEqualTo(String value) {
            addCriterion("platform_trade_no >=", value, "platformTradeNo");
            return (Criteria) this;
        }

        public Criteria andPlatformTradeNoLessThan(String value) {
            addCriterion("platform_trade_no <", value, "platformTradeNo");
            return (Criteria) this;
        }

        public Criteria andPlatformTradeNoLessThanOrEqualTo(String value) {
            addCriterion("platform_trade_no <=", value, "platformTradeNo");
            return (Criteria) this;
        }

        public Criteria andPlatformTradeNoLike(String value) {
            addCriterion("platform_trade_no like", value, "platformTradeNo");
            return (Criteria) this;
        }

        public Criteria andPlatformTradeNoNotLike(String value) {
            addCriterion("platform_trade_no not like", value, "platformTradeNo");
            return (Criteria) this;
        }

        public Criteria andPlatformTradeNoIn(List<String> values) {
            addCriterion("platform_trade_no in", values, "platformTradeNo");
            return (Criteria) this;
        }

        public Criteria andPlatformTradeNoNotIn(List<String> values) {
            addCriterion("platform_trade_no not in", values, "platformTradeNo");
            return (Criteria) this;
        }

        public Criteria andPlatformTradeNoBetween(String value1, String value2) {
            addCriterion("platform_trade_no between", value1, value2, "platformTradeNo");
            return (Criteria) this;
        }

        public Criteria andPlatformTradeNoNotBetween(String value1, String value2) {
            addCriterion("platform_trade_no not between", value1, value2, "platformTradeNo");
            return (Criteria) this;
        }

        public Criteria andPlatformLogNoIsNull() {
            addCriterion("platform_log_no is null");
            return (Criteria) this;
        }

        public Criteria andPlatformLogNoIsNotNull() {
            addCriterion("platform_log_no is not null");
            return (Criteria) this;
        }

        public Criteria andPlatformLogNoEqualTo(String value) {
            addCriterion("platform_log_no =", value, "platformLogNo");
            return (Criteria) this;
        }

        public Criteria andPlatformLogNoNotEqualTo(String value) {
            addCriterion("platform_log_no <>", value, "platformLogNo");
            return (Criteria) this;
        }

        public Criteria andPlatformLogNoGreaterThan(String value) {
            addCriterion("platform_log_no >", value, "platformLogNo");
            return (Criteria) this;
        }

        public Criteria andPlatformLogNoGreaterThanOrEqualTo(String value) {
            addCriterion("platform_log_no >=", value, "platformLogNo");
            return (Criteria) this;
        }

        public Criteria andPlatformLogNoLessThan(String value) {
            addCriterion("platform_log_no <", value, "platformLogNo");
            return (Criteria) this;
        }

        public Criteria andPlatformLogNoLessThanOrEqualTo(String value) {
            addCriterion("platform_log_no <=", value, "platformLogNo");
            return (Criteria) this;
        }

        public Criteria andPlatformLogNoLike(String value) {
            addCriterion("platform_log_no like", value, "platformLogNo");
            return (Criteria) this;
        }

        public Criteria andPlatformLogNoNotLike(String value) {
            addCriterion("platform_log_no not like", value, "platformLogNo");
            return (Criteria) this;
        }

        public Criteria andPlatformLogNoIn(List<String> values) {
            addCriterion("platform_log_no in", values, "platformLogNo");
            return (Criteria) this;
        }

        public Criteria andPlatformLogNoNotIn(List<String> values) {
            addCriterion("platform_log_no not in", values, "platformLogNo");
            return (Criteria) this;
        }

        public Criteria andPlatformLogNoBetween(String value1, String value2) {
            addCriterion("platform_log_no between", value1, value2, "platformLogNo");
            return (Criteria) this;
        }

        public Criteria andPlatformLogNoNotBetween(String value1, String value2) {
            addCriterion("platform_log_no not between", value1, value2, "platformLogNo");
            return (Criteria) this;
        }

        public Criteria andPlatformAppidIsNull() {
            addCriterion("platform_appid is null");
            return (Criteria) this;
        }

        public Criteria andPlatformAppidIsNotNull() {
            addCriterion("platform_appid is not null");
            return (Criteria) this;
        }

        public Criteria andPlatformAppidEqualTo(String value) {
            addCriterion("platform_appid =", value, "platformAppid");
            return (Criteria) this;
        }

        public Criteria andPlatformAppidNotEqualTo(String value) {
            addCriterion("platform_appid <>", value, "platformAppid");
            return (Criteria) this;
        }

        public Criteria andPlatformAppidGreaterThan(String value) {
            addCriterion("platform_appid >", value, "platformAppid");
            return (Criteria) this;
        }

        public Criteria andPlatformAppidGreaterThanOrEqualTo(String value) {
            addCriterion("platform_appid >=", value, "platformAppid");
            return (Criteria) this;
        }

        public Criteria andPlatformAppidLessThan(String value) {
            addCriterion("platform_appid <", value, "platformAppid");
            return (Criteria) this;
        }

        public Criteria andPlatformAppidLessThanOrEqualTo(String value) {
            addCriterion("platform_appid <=", value, "platformAppid");
            return (Criteria) this;
        }

        public Criteria andPlatformAppidLike(String value) {
            addCriterion("platform_appid like", value, "platformAppid");
            return (Criteria) this;
        }

        public Criteria andPlatformAppidNotLike(String value) {
            addCriterion("platform_appid not like", value, "platformAppid");
            return (Criteria) this;
        }

        public Criteria andPlatformAppidIn(List<String> values) {
            addCriterion("platform_appid in", values, "platformAppid");
            return (Criteria) this;
        }

        public Criteria andPlatformAppidNotIn(List<String> values) {
            addCriterion("platform_appid not in", values, "platformAppid");
            return (Criteria) this;
        }

        public Criteria andPlatformAppidBetween(String value1, String value2) {
            addCriterion("platform_appid between", value1, value2, "platformAppid");
            return (Criteria) this;
        }

        public Criteria andPlatformAppidNotBetween(String value1, String value2) {
            addCriterion("platform_appid not between", value1, value2, "platformAppid");
            return (Criteria) this;
        }

        public Criteria andPlatformRateIsNull() {
            addCriterion("platform_rate is null");
            return (Criteria) this;
        }

        public Criteria andPlatformRateIsNotNull() {
            addCriterion("platform_rate is not null");
            return (Criteria) this;
        }

        public Criteria andPlatformRateEqualTo(BigDecimal value) {
            addCriterion("platform_rate =", value, "platformRate");
            return (Criteria) this;
        }

        public Criteria andPlatformRateNotEqualTo(BigDecimal value) {
            addCriterion("platform_rate <>", value, "platformRate");
            return (Criteria) this;
        }

        public Criteria andPlatformRateGreaterThan(BigDecimal value) {
            addCriterion("platform_rate >", value, "platformRate");
            return (Criteria) this;
        }

        public Criteria andPlatformRateGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("platform_rate >=", value, "platformRate");
            return (Criteria) this;
        }

        public Criteria andPlatformRateLessThan(BigDecimal value) {
            addCriterion("platform_rate <", value, "platformRate");
            return (Criteria) this;
        }

        public Criteria andPlatformRateLessThanOrEqualTo(BigDecimal value) {
            addCriterion("platform_rate <=", value, "platformRate");
            return (Criteria) this;
        }

        public Criteria andPlatformRateIn(List<BigDecimal> values) {
            addCriterion("platform_rate in", values, "platformRate");
            return (Criteria) this;
        }

        public Criteria andPlatformRateNotIn(List<BigDecimal> values) {
            addCriterion("platform_rate not in", values, "platformRate");
            return (Criteria) this;
        }

        public Criteria andPlatformRateBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("platform_rate between", value1, value2, "platformRate");
            return (Criteria) this;
        }

        public Criteria andPlatformRateNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("platform_rate not between", value1, value2, "platformRate");
            return (Criteria) this;
        }

        public Criteria andPlatformCommissionIsNull() {
            addCriterion("platform_commission is null");
            return (Criteria) this;
        }

        public Criteria andPlatformCommissionIsNotNull() {
            addCriterion("platform_commission is not null");
            return (Criteria) this;
        }

        public Criteria andPlatformCommissionEqualTo(BigDecimal value) {
            addCriterion("platform_commission =", value, "platformCommission");
            return (Criteria) this;
        }

        public Criteria andPlatformCommissionNotEqualTo(BigDecimal value) {
            addCriterion("platform_commission <>", value, "platformCommission");
            return (Criteria) this;
        }

        public Criteria andPlatformCommissionGreaterThan(BigDecimal value) {
            addCriterion("platform_commission >", value, "platformCommission");
            return (Criteria) this;
        }

        public Criteria andPlatformCommissionGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("platform_commission >=", value, "platformCommission");
            return (Criteria) this;
        }

        public Criteria andPlatformCommissionLessThan(BigDecimal value) {
            addCriterion("platform_commission <", value, "platformCommission");
            return (Criteria) this;
        }

        public Criteria andPlatformCommissionLessThanOrEqualTo(BigDecimal value) {
            addCriterion("platform_commission <=", value, "platformCommission");
            return (Criteria) this;
        }

        public Criteria andPlatformCommissionIn(List<BigDecimal> values) {
            addCriterion("platform_commission in", values, "platformCommission");
            return (Criteria) this;
        }

        public Criteria andPlatformCommissionNotIn(List<BigDecimal> values) {
            addCriterion("platform_commission not in", values, "platformCommission");
            return (Criteria) this;
        }

        public Criteria andPlatformCommissionBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("platform_commission between", value1, value2, "platformCommission");
            return (Criteria) this;
        }

        public Criteria andPlatformCommissionNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("platform_commission not between", value1, value2, "platformCommission");
            return (Criteria) this;
        }

        public Criteria andPayAppidIsNull() {
            addCriterion("pay_appid is null");
            return (Criteria) this;
        }

        public Criteria andPayAppidIsNotNull() {
            addCriterion("pay_appid is not null");
            return (Criteria) this;
        }

        public Criteria andPayAppidEqualTo(String value) {
            addCriterion("pay_appid =", value, "payAppid");
            return (Criteria) this;
        }

        public Criteria andPayAppidNotEqualTo(String value) {
            addCriterion("pay_appid <>", value, "payAppid");
            return (Criteria) this;
        }

        public Criteria andPayAppidGreaterThan(String value) {
            addCriterion("pay_appid >", value, "payAppid");
            return (Criteria) this;
        }

        public Criteria andPayAppidGreaterThanOrEqualTo(String value) {
            addCriterion("pay_appid >=", value, "payAppid");
            return (Criteria) this;
        }

        public Criteria andPayAppidLessThan(String value) {
            addCriterion("pay_appid <", value, "payAppid");
            return (Criteria) this;
        }

        public Criteria andPayAppidLessThanOrEqualTo(String value) {
            addCriterion("pay_appid <=", value, "payAppid");
            return (Criteria) this;
        }

        public Criteria andPayAppidLike(String value) {
            addCriterion("pay_appid like", value, "payAppid");
            return (Criteria) this;
        }

        public Criteria andPayAppidNotLike(String value) {
            addCriterion("pay_appid not like", value, "payAppid");
            return (Criteria) this;
        }

        public Criteria andPayAppidIn(List<String> values) {
            addCriterion("pay_appid in", values, "payAppid");
            return (Criteria) this;
        }

        public Criteria andPayAppidNotIn(List<String> values) {
            addCriterion("pay_appid not in", values, "payAppid");
            return (Criteria) this;
        }

        public Criteria andPayAppidBetween(String value1, String value2) {
            addCriterion("pay_appid between", value1, value2, "payAppid");
            return (Criteria) this;
        }

        public Criteria andPayAppidNotBetween(String value1, String value2) {
            addCriterion("pay_appid not between", value1, value2, "payAppid");
            return (Criteria) this;
        }

        public Criteria andPayUserIdIsNull() {
            addCriterion("pay_user_id is null");
            return (Criteria) this;
        }

        public Criteria andPayUserIdIsNotNull() {
            addCriterion("pay_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andPayUserIdEqualTo(String value) {
            addCriterion("pay_user_id =", value, "payUserId");
            return (Criteria) this;
        }

        public Criteria andPayUserIdNotEqualTo(String value) {
            addCriterion("pay_user_id <>", value, "payUserId");
            return (Criteria) this;
        }

        public Criteria andPayUserIdGreaterThan(String value) {
            addCriterion("pay_user_id >", value, "payUserId");
            return (Criteria) this;
        }

        public Criteria andPayUserIdGreaterThanOrEqualTo(String value) {
            addCriterion("pay_user_id >=", value, "payUserId");
            return (Criteria) this;
        }

        public Criteria andPayUserIdLessThan(String value) {
            addCriterion("pay_user_id <", value, "payUserId");
            return (Criteria) this;
        }

        public Criteria andPayUserIdLessThanOrEqualTo(String value) {
            addCriterion("pay_user_id <=", value, "payUserId");
            return (Criteria) this;
        }

        public Criteria andPayUserIdLike(String value) {
            addCriterion("pay_user_id like", value, "payUserId");
            return (Criteria) this;
        }

        public Criteria andPayUserIdNotLike(String value) {
            addCriterion("pay_user_id not like", value, "payUserId");
            return (Criteria) this;
        }

        public Criteria andPayUserIdIn(List<String> values) {
            addCriterion("pay_user_id in", values, "payUserId");
            return (Criteria) this;
        }

        public Criteria andPayUserIdNotIn(List<String> values) {
            addCriterion("pay_user_id not in", values, "payUserId");
            return (Criteria) this;
        }

        public Criteria andPayUserIdBetween(String value1, String value2) {
            addCriterion("pay_user_id between", value1, value2, "payUserId");
            return (Criteria) this;
        }

        public Criteria andPayUserIdNotBetween(String value1, String value2) {
            addCriterion("pay_user_id not between", value1, value2, "payUserId");
            return (Criteria) this;
        }

        public Criteria andPayModeIsNull() {
            addCriterion("pay_mode is null");
            return (Criteria) this;
        }

        public Criteria andPayModeIsNotNull() {
            addCriterion("pay_mode is not null");
            return (Criteria) this;
        }

        public Criteria andPayModeEqualTo(String value) {
            addCriterion("pay_mode =", value, "payMode");
            return (Criteria) this;
        }

        public Criteria andPayModeNotEqualTo(String value) {
            addCriterion("pay_mode <>", value, "payMode");
            return (Criteria) this;
        }

        public Criteria andPayModeGreaterThan(String value) {
            addCriterion("pay_mode >", value, "payMode");
            return (Criteria) this;
        }

        public Criteria andPayModeGreaterThanOrEqualTo(String value) {
            addCriterion("pay_mode >=", value, "payMode");
            return (Criteria) this;
        }

        public Criteria andPayModeLessThan(String value) {
            addCriterion("pay_mode <", value, "payMode");
            return (Criteria) this;
        }

        public Criteria andPayModeLessThanOrEqualTo(String value) {
            addCriterion("pay_mode <=", value, "payMode");
            return (Criteria) this;
        }

        public Criteria andPayModeLike(String value) {
            addCriterion("pay_mode like", value, "payMode");
            return (Criteria) this;
        }

        public Criteria andPayModeNotLike(String value) {
            addCriterion("pay_mode not like", value, "payMode");
            return (Criteria) this;
        }

        public Criteria andPayModeIn(List<String> values) {
            addCriterion("pay_mode in", values, "payMode");
            return (Criteria) this;
        }

        public Criteria andPayModeNotIn(List<String> values) {
            addCriterion("pay_mode not in", values, "payMode");
            return (Criteria) this;
        }

        public Criteria andPayModeBetween(String value1, String value2) {
            addCriterion("pay_mode between", value1, value2, "payMode");
            return (Criteria) this;
        }

        public Criteria andPayModeNotBetween(String value1, String value2) {
            addCriterion("pay_mode not between", value1, value2, "payMode");
            return (Criteria) this;
        }

        public Criteria andOutTradeNoIsNull() {
            addCriterion("out_trade_no is null");
            return (Criteria) this;
        }

        public Criteria andOutTradeNoIsNotNull() {
            addCriterion("out_trade_no is not null");
            return (Criteria) this;
        }

        public Criteria andOutTradeNoEqualTo(String value) {
            addCriterion("out_trade_no =", value, "outTradeNo");
            return (Criteria) this;
        }

        public Criteria andOutTradeNoNotEqualTo(String value) {
            addCriterion("out_trade_no <>", value, "outTradeNo");
            return (Criteria) this;
        }

        public Criteria andOutTradeNoGreaterThan(String value) {
            addCriterion("out_trade_no >", value, "outTradeNo");
            return (Criteria) this;
        }

        public Criteria andOutTradeNoGreaterThanOrEqualTo(String value) {
            addCriterion("out_trade_no >=", value, "outTradeNo");
            return (Criteria) this;
        }

        public Criteria andOutTradeNoLessThan(String value) {
            addCriterion("out_trade_no <", value, "outTradeNo");
            return (Criteria) this;
        }

        public Criteria andOutTradeNoLessThanOrEqualTo(String value) {
            addCriterion("out_trade_no <=", value, "outTradeNo");
            return (Criteria) this;
        }

        public Criteria andOutTradeNoLike(String value) {
            addCriterion("out_trade_no like", value, "outTradeNo");
            return (Criteria) this;
        }

        public Criteria andOutTradeNoNotLike(String value) {
            addCriterion("out_trade_no not like", value, "outTradeNo");
            return (Criteria) this;
        }

        public Criteria andOutTradeNoIn(List<String> values) {
            addCriterion("out_trade_no in", values, "outTradeNo");
            return (Criteria) this;
        }

        public Criteria andOutTradeNoNotIn(List<String> values) {
            addCriterion("out_trade_no not in", values, "outTradeNo");
            return (Criteria) this;
        }

        public Criteria andOutTradeNoBetween(String value1, String value2) {
            addCriterion("out_trade_no between", value1, value2, "outTradeNo");
            return (Criteria) this;
        }

        public Criteria andOutTradeNoNotBetween(String value1, String value2) {
            addCriterion("out_trade_no not between", value1, value2, "outTradeNo");
            return (Criteria) this;
        }

        public Criteria andTradeAmountIsNull() {
            addCriterion("trade_amount is null");
            return (Criteria) this;
        }

        public Criteria andTradeAmountIsNotNull() {
            addCriterion("trade_amount is not null");
            return (Criteria) this;
        }

        public Criteria andTradeAmountEqualTo(BigDecimal value) {
            addCriterion("trade_amount =", value, "tradeAmount");
            return (Criteria) this;
        }

        public Criteria andTradeAmountNotEqualTo(BigDecimal value) {
            addCriterion("trade_amount <>", value, "tradeAmount");
            return (Criteria) this;
        }

        public Criteria andTradeAmountGreaterThan(BigDecimal value) {
            addCriterion("trade_amount >", value, "tradeAmount");
            return (Criteria) this;
        }

        public Criteria andTradeAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("trade_amount >=", value, "tradeAmount");
            return (Criteria) this;
        }

        public Criteria andTradeAmountLessThan(BigDecimal value) {
            addCriterion("trade_amount <", value, "tradeAmount");
            return (Criteria) this;
        }

        public Criteria andTradeAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("trade_amount <=", value, "tradeAmount");
            return (Criteria) this;
        }

        public Criteria andTradeAmountIn(List<BigDecimal> values) {
            addCriterion("trade_amount in", values, "tradeAmount");
            return (Criteria) this;
        }

        public Criteria andTradeAmountNotIn(List<BigDecimal> values) {
            addCriterion("trade_amount not in", values, "tradeAmount");
            return (Criteria) this;
        }

        public Criteria andTradeAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("trade_amount between", value1, value2, "tradeAmount");
            return (Criteria) this;
        }

        public Criteria andTradeAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("trade_amount not between", value1, value2, "tradeAmount");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountSatisfyIsNull() {
            addCriterion("store_discount_satisfy is null");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountSatisfyIsNotNull() {
            addCriterion("store_discount_satisfy is not null");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountSatisfyEqualTo(Boolean value) {
            addCriterion("store_discount_satisfy =", value, "storeDiscountSatisfy");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountSatisfyNotEqualTo(Boolean value) {
            addCriterion("store_discount_satisfy <>", value, "storeDiscountSatisfy");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountSatisfyGreaterThan(Boolean value) {
            addCriterion("store_discount_satisfy >", value, "storeDiscountSatisfy");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountSatisfyGreaterThanOrEqualTo(Boolean value) {
            addCriterion("store_discount_satisfy >=", value, "storeDiscountSatisfy");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountSatisfyLessThan(Boolean value) {
            addCriterion("store_discount_satisfy <", value, "storeDiscountSatisfy");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountSatisfyLessThanOrEqualTo(Boolean value) {
            addCriterion("store_discount_satisfy <=", value, "storeDiscountSatisfy");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountSatisfyIn(List<Boolean> values) {
            addCriterion("store_discount_satisfy in", values, "storeDiscountSatisfy");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountSatisfyNotIn(List<Boolean> values) {
            addCriterion("store_discount_satisfy not in", values, "storeDiscountSatisfy");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountSatisfyBetween(Boolean value1, Boolean value2) {
            addCriterion("store_discount_satisfy between", value1, value2, "storeDiscountSatisfy");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountSatisfyNotBetween(Boolean value1, Boolean value2) {
            addCriterion("store_discount_satisfy not between", value1, value2, "storeDiscountSatisfy");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountIdIsNull() {
            addCriterion("store_discount_id is null");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountIdIsNotNull() {
            addCriterion("store_discount_id is not null");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountIdEqualTo(Long value) {
            addCriterion("store_discount_id =", value, "storeDiscountId");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountIdNotEqualTo(Long value) {
            addCriterion("store_discount_id <>", value, "storeDiscountId");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountIdGreaterThan(Long value) {
            addCriterion("store_discount_id >", value, "storeDiscountId");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountIdGreaterThanOrEqualTo(Long value) {
            addCriterion("store_discount_id >=", value, "storeDiscountId");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountIdLessThan(Long value) {
            addCriterion("store_discount_id <", value, "storeDiscountId");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountIdLessThanOrEqualTo(Long value) {
            addCriterion("store_discount_id <=", value, "storeDiscountId");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountIdIn(List<Long> values) {
            addCriterion("store_discount_id in", values, "storeDiscountId");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountIdNotIn(List<Long> values) {
            addCriterion("store_discount_id not in", values, "storeDiscountId");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountIdBetween(Long value1, Long value2) {
            addCriterion("store_discount_id between", value1, value2, "storeDiscountId");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountIdNotBetween(Long value1, Long value2) {
            addCriterion("store_discount_id not between", value1, value2, "storeDiscountId");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountNameIsNull() {
            addCriterion("store_discount_name is null");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountNameIsNotNull() {
            addCriterion("store_discount_name is not null");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountNameEqualTo(String value) {
            addCriterion("store_discount_name =", value, "storeDiscountName");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountNameNotEqualTo(String value) {
            addCriterion("store_discount_name <>", value, "storeDiscountName");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountNameGreaterThan(String value) {
            addCriterion("store_discount_name >", value, "storeDiscountName");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountNameGreaterThanOrEqualTo(String value) {
            addCriterion("store_discount_name >=", value, "storeDiscountName");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountNameLessThan(String value) {
            addCriterion("store_discount_name <", value, "storeDiscountName");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountNameLessThanOrEqualTo(String value) {
            addCriterion("store_discount_name <=", value, "storeDiscountName");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountNameLike(String value) {
            addCriterion("store_discount_name like", value, "storeDiscountName");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountNameNotLike(String value) {
            addCriterion("store_discount_name not like", value, "storeDiscountName");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountNameIn(List<String> values) {
            addCriterion("store_discount_name in", values, "storeDiscountName");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountNameNotIn(List<String> values) {
            addCriterion("store_discount_name not in", values, "storeDiscountName");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountNameBetween(String value1, String value2) {
            addCriterion("store_discount_name between", value1, value2, "storeDiscountName");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountNameNotBetween(String value1, String value2) {
            addCriterion("store_discount_name not between", value1, value2, "storeDiscountName");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountTypeIsNull() {
            addCriterion("store_discount_type is null");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountTypeIsNotNull() {
            addCriterion("store_discount_type is not null");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountTypeEqualTo(Integer value) {
            addCriterion("store_discount_type =", value, "storeDiscountType");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountTypeNotEqualTo(Integer value) {
            addCriterion("store_discount_type <>", value, "storeDiscountType");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountTypeGreaterThan(Integer value) {
            addCriterion("store_discount_type >", value, "storeDiscountType");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("store_discount_type >=", value, "storeDiscountType");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountTypeLessThan(Integer value) {
            addCriterion("store_discount_type <", value, "storeDiscountType");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountTypeLessThanOrEqualTo(Integer value) {
            addCriterion("store_discount_type <=", value, "storeDiscountType");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountTypeIn(List<Integer> values) {
            addCriterion("store_discount_type in", values, "storeDiscountType");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountTypeNotIn(List<Integer> values) {
            addCriterion("store_discount_type not in", values, "storeDiscountType");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountTypeBetween(Integer value1, Integer value2) {
            addCriterion("store_discount_type between", value1, value2, "storeDiscountType");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("store_discount_type not between", value1, value2, "storeDiscountType");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountConditionIsNull() {
            addCriterion("store_discount_condition is null");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountConditionIsNotNull() {
            addCriterion("store_discount_condition is not null");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountConditionEqualTo(BigDecimal value) {
            addCriterion("store_discount_condition =", value, "storeDiscountCondition");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountConditionNotEqualTo(BigDecimal value) {
            addCriterion("store_discount_condition <>", value, "storeDiscountCondition");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountConditionGreaterThan(BigDecimal value) {
            addCriterion("store_discount_condition >", value, "storeDiscountCondition");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountConditionGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("store_discount_condition >=", value, "storeDiscountCondition");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountConditionLessThan(BigDecimal value) {
            addCriterion("store_discount_condition <", value, "storeDiscountCondition");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountConditionLessThanOrEqualTo(BigDecimal value) {
            addCriterion("store_discount_condition <=", value, "storeDiscountCondition");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountConditionIn(List<BigDecimal> values) {
            addCriterion("store_discount_condition in", values, "storeDiscountCondition");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountConditionNotIn(List<BigDecimal> values) {
            addCriterion("store_discount_condition not in", values, "storeDiscountCondition");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountConditionBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("store_discount_condition between", value1, value2, "storeDiscountCondition");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountConditionNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("store_discount_condition not between", value1, value2, "storeDiscountCondition");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountPriceIsNull() {
            addCriterion("store_discount_price is null");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountPriceIsNotNull() {
            addCriterion("store_discount_price is not null");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountPriceEqualTo(BigDecimal value) {
            addCriterion("store_discount_price =", value, "storeDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountPriceNotEqualTo(BigDecimal value) {
            addCriterion("store_discount_price <>", value, "storeDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountPriceGreaterThan(BigDecimal value) {
            addCriterion("store_discount_price >", value, "storeDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("store_discount_price >=", value, "storeDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountPriceLessThan(BigDecimal value) {
            addCriterion("store_discount_price <", value, "storeDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("store_discount_price <=", value, "storeDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountPriceIn(List<BigDecimal> values) {
            addCriterion("store_discount_price in", values, "storeDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountPriceNotIn(List<BigDecimal> values) {
            addCriterion("store_discount_price not in", values, "storeDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("store_discount_price between", value1, value2, "storeDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("store_discount_price not between", value1, value2, "storeDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountFinalCostPriceIsNull() {
            addCriterion("store_discount_final_cost_price is null");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountFinalCostPriceIsNotNull() {
            addCriterion("store_discount_final_cost_price is not null");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountFinalCostPriceEqualTo(BigDecimal value) {
            addCriterion("store_discount_final_cost_price =", value, "storeDiscountFinalCostPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountFinalCostPriceNotEqualTo(BigDecimal value) {
            addCriterion("store_discount_final_cost_price <>", value, "storeDiscountFinalCostPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountFinalCostPriceGreaterThan(BigDecimal value) {
            addCriterion("store_discount_final_cost_price >", value, "storeDiscountFinalCostPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountFinalCostPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("store_discount_final_cost_price >=", value, "storeDiscountFinalCostPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountFinalCostPriceLessThan(BigDecimal value) {
            addCriterion("store_discount_final_cost_price <", value, "storeDiscountFinalCostPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountFinalCostPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("store_discount_final_cost_price <=", value, "storeDiscountFinalCostPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountFinalCostPriceIn(List<BigDecimal> values) {
            addCriterion("store_discount_final_cost_price in", values, "storeDiscountFinalCostPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountFinalCostPriceNotIn(List<BigDecimal> values) {
            addCriterion("store_discount_final_cost_price not in", values, "storeDiscountFinalCostPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountFinalCostPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("store_discount_final_cost_price between", value1, value2, "storeDiscountFinalCostPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountFinalCostPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("store_discount_final_cost_price not between", value1, value2, "storeDiscountFinalCostPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountActualPriceIsNull() {
            addCriterion("store_discount_actual_price is null");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountActualPriceIsNotNull() {
            addCriterion("store_discount_actual_price is not null");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountActualPriceEqualTo(BigDecimal value) {
            addCriterion("store_discount_actual_price =", value, "storeDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountActualPriceNotEqualTo(BigDecimal value) {
            addCriterion("store_discount_actual_price <>", value, "storeDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountActualPriceGreaterThan(BigDecimal value) {
            addCriterion("store_discount_actual_price >", value, "storeDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountActualPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("store_discount_actual_price >=", value, "storeDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountActualPriceLessThan(BigDecimal value) {
            addCriterion("store_discount_actual_price <", value, "storeDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountActualPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("store_discount_actual_price <=", value, "storeDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountActualPriceIn(List<BigDecimal> values) {
            addCriterion("store_discount_actual_price in", values, "storeDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountActualPriceNotIn(List<BigDecimal> values) {
            addCriterion("store_discount_actual_price not in", values, "storeDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountActualPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("store_discount_actual_price between", value1, value2, "storeDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountActualPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("store_discount_actual_price not between", value1, value2, "storeDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountProfitPriceIsNull() {
            addCriterion("store_discount_profit_price is null");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountProfitPriceIsNotNull() {
            addCriterion("store_discount_profit_price is not null");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountProfitPriceEqualTo(BigDecimal value) {
            addCriterion("store_discount_profit_price =", value, "storeDiscountProfitPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountProfitPriceNotEqualTo(BigDecimal value) {
            addCriterion("store_discount_profit_price <>", value, "storeDiscountProfitPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountProfitPriceGreaterThan(BigDecimal value) {
            addCriterion("store_discount_profit_price >", value, "storeDiscountProfitPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountProfitPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("store_discount_profit_price >=", value, "storeDiscountProfitPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountProfitPriceLessThan(BigDecimal value) {
            addCriterion("store_discount_profit_price <", value, "storeDiscountProfitPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountProfitPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("store_discount_profit_price <=", value, "storeDiscountProfitPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountProfitPriceIn(List<BigDecimal> values) {
            addCriterion("store_discount_profit_price in", values, "storeDiscountProfitPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountProfitPriceNotIn(List<BigDecimal> values) {
            addCriterion("store_discount_profit_price not in", values, "storeDiscountProfitPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountProfitPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("store_discount_profit_price between", value1, value2, "storeDiscountProfitPrice");
            return (Criteria) this;
        }

        public Criteria andStoreDiscountProfitPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("store_discount_profit_price not between", value1, value2, "storeDiscountProfitPrice");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNull() {
            addCriterion("user_id is null");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNotNull() {
            addCriterion("user_id is not null");
            return (Criteria) this;
        }

        public Criteria andUserIdEqualTo(Integer value) {
            addCriterion("user_id =", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotEqualTo(Integer value) {
            addCriterion("user_id <>", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThan(Integer value) {
            addCriterion("user_id >", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("user_id >=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThan(Integer value) {
            addCriterion("user_id <", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThanOrEqualTo(Integer value) {
            addCriterion("user_id <=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdIn(List<Integer> values) {
            addCriterion("user_id in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotIn(List<Integer> values) {
            addCriterion("user_id not in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdBetween(Integer value1, Integer value2) {
            addCriterion("user_id between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotBetween(Integer value1, Integer value2) {
            addCriterion("user_id not between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andUserPhoneIsNull() {
            addCriterion("user_phone is null");
            return (Criteria) this;
        }

        public Criteria andUserPhoneIsNotNull() {
            addCriterion("user_phone is not null");
            return (Criteria) this;
        }

        public Criteria andUserPhoneEqualTo(String value) {
            addCriterion("user_phone =", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneNotEqualTo(String value) {
            addCriterion("user_phone <>", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneGreaterThan(String value) {
            addCriterion("user_phone >", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneGreaterThanOrEqualTo(String value) {
            addCriterion("user_phone >=", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneLessThan(String value) {
            addCriterion("user_phone <", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneLessThanOrEqualTo(String value) {
            addCriterion("user_phone <=", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneLike(String value) {
            addCriterion("user_phone like", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneNotLike(String value) {
            addCriterion("user_phone not like", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneIn(List<String> values) {
            addCriterion("user_phone in", values, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneNotIn(List<String> values) {
            addCriterion("user_phone not in", values, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneBetween(String value1, String value2) {
            addCriterion("user_phone between", value1, value2, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneNotBetween(String value1, String value2) {
            addCriterion("user_phone not between", value1, value2, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserDiscountIdIsNull() {
            addCriterion("user_discount_id is null");
            return (Criteria) this;
        }

        public Criteria andUserDiscountIdIsNotNull() {
            addCriterion("user_discount_id is not null");
            return (Criteria) this;
        }

        public Criteria andUserDiscountIdEqualTo(Long value) {
            addCriterion("user_discount_id =", value, "userDiscountId");
            return (Criteria) this;
        }

        public Criteria andUserDiscountIdNotEqualTo(Long value) {
            addCriterion("user_discount_id <>", value, "userDiscountId");
            return (Criteria) this;
        }

        public Criteria andUserDiscountIdGreaterThan(Long value) {
            addCriterion("user_discount_id >", value, "userDiscountId");
            return (Criteria) this;
        }

        public Criteria andUserDiscountIdGreaterThanOrEqualTo(Long value) {
            addCriterion("user_discount_id >=", value, "userDiscountId");
            return (Criteria) this;
        }

        public Criteria andUserDiscountIdLessThan(Long value) {
            addCriterion("user_discount_id <", value, "userDiscountId");
            return (Criteria) this;
        }

        public Criteria andUserDiscountIdLessThanOrEqualTo(Long value) {
            addCriterion("user_discount_id <=", value, "userDiscountId");
            return (Criteria) this;
        }

        public Criteria andUserDiscountIdIn(List<Long> values) {
            addCriterion("user_discount_id in", values, "userDiscountId");
            return (Criteria) this;
        }

        public Criteria andUserDiscountIdNotIn(List<Long> values) {
            addCriterion("user_discount_id not in", values, "userDiscountId");
            return (Criteria) this;
        }

        public Criteria andUserDiscountIdBetween(Long value1, Long value2) {
            addCriterion("user_discount_id between", value1, value2, "userDiscountId");
            return (Criteria) this;
        }

        public Criteria andUserDiscountIdNotBetween(Long value1, Long value2) {
            addCriterion("user_discount_id not between", value1, value2, "userDiscountId");
            return (Criteria) this;
        }

        public Criteria andUserDiscountNameIsNull() {
            addCriterion("user_discount_name is null");
            return (Criteria) this;
        }

        public Criteria andUserDiscountNameIsNotNull() {
            addCriterion("user_discount_name is not null");
            return (Criteria) this;
        }

        public Criteria andUserDiscountNameEqualTo(String value) {
            addCriterion("user_discount_name =", value, "userDiscountName");
            return (Criteria) this;
        }

        public Criteria andUserDiscountNameNotEqualTo(String value) {
            addCriterion("user_discount_name <>", value, "userDiscountName");
            return (Criteria) this;
        }

        public Criteria andUserDiscountNameGreaterThan(String value) {
            addCriterion("user_discount_name >", value, "userDiscountName");
            return (Criteria) this;
        }

        public Criteria andUserDiscountNameGreaterThanOrEqualTo(String value) {
            addCriterion("user_discount_name >=", value, "userDiscountName");
            return (Criteria) this;
        }

        public Criteria andUserDiscountNameLessThan(String value) {
            addCriterion("user_discount_name <", value, "userDiscountName");
            return (Criteria) this;
        }

        public Criteria andUserDiscountNameLessThanOrEqualTo(String value) {
            addCriterion("user_discount_name <=", value, "userDiscountName");
            return (Criteria) this;
        }

        public Criteria andUserDiscountNameLike(String value) {
            addCriterion("user_discount_name like", value, "userDiscountName");
            return (Criteria) this;
        }

        public Criteria andUserDiscountNameNotLike(String value) {
            addCriterion("user_discount_name not like", value, "userDiscountName");
            return (Criteria) this;
        }

        public Criteria andUserDiscountNameIn(List<String> values) {
            addCriterion("user_discount_name in", values, "userDiscountName");
            return (Criteria) this;
        }

        public Criteria andUserDiscountNameNotIn(List<String> values) {
            addCriterion("user_discount_name not in", values, "userDiscountName");
            return (Criteria) this;
        }

        public Criteria andUserDiscountNameBetween(String value1, String value2) {
            addCriterion("user_discount_name between", value1, value2, "userDiscountName");
            return (Criteria) this;
        }

        public Criteria andUserDiscountNameNotBetween(String value1, String value2) {
            addCriterion("user_discount_name not between", value1, value2, "userDiscountName");
            return (Criteria) this;
        }

        public Criteria andUserDiscountTypeIsNull() {
            addCriterion("user_discount_type is null");
            return (Criteria) this;
        }

        public Criteria andUserDiscountTypeIsNotNull() {
            addCriterion("user_discount_type is not null");
            return (Criteria) this;
        }

        public Criteria andUserDiscountTypeEqualTo(Integer value) {
            addCriterion("user_discount_type =", value, "userDiscountType");
            return (Criteria) this;
        }

        public Criteria andUserDiscountTypeNotEqualTo(Integer value) {
            addCriterion("user_discount_type <>", value, "userDiscountType");
            return (Criteria) this;
        }

        public Criteria andUserDiscountTypeGreaterThan(Integer value) {
            addCriterion("user_discount_type >", value, "userDiscountType");
            return (Criteria) this;
        }

        public Criteria andUserDiscountTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("user_discount_type >=", value, "userDiscountType");
            return (Criteria) this;
        }

        public Criteria andUserDiscountTypeLessThan(Integer value) {
            addCriterion("user_discount_type <", value, "userDiscountType");
            return (Criteria) this;
        }

        public Criteria andUserDiscountTypeLessThanOrEqualTo(Integer value) {
            addCriterion("user_discount_type <=", value, "userDiscountType");
            return (Criteria) this;
        }

        public Criteria andUserDiscountTypeIn(List<Integer> values) {
            addCriterion("user_discount_type in", values, "userDiscountType");
            return (Criteria) this;
        }

        public Criteria andUserDiscountTypeNotIn(List<Integer> values) {
            addCriterion("user_discount_type not in", values, "userDiscountType");
            return (Criteria) this;
        }

        public Criteria andUserDiscountTypeBetween(Integer value1, Integer value2) {
            addCriterion("user_discount_type between", value1, value2, "userDiscountType");
            return (Criteria) this;
        }

        public Criteria andUserDiscountTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("user_discount_type not between", value1, value2, "userDiscountType");
            return (Criteria) this;
        }

        public Criteria andUserDiscountPriceIsNull() {
            addCriterion("user_discount_price is null");
            return (Criteria) this;
        }

        public Criteria andUserDiscountPriceIsNotNull() {
            addCriterion("user_discount_price is not null");
            return (Criteria) this;
        }

        public Criteria andUserDiscountPriceEqualTo(BigDecimal value) {
            addCriterion("user_discount_price =", value, "userDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andUserDiscountPriceNotEqualTo(BigDecimal value) {
            addCriterion("user_discount_price <>", value, "userDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andUserDiscountPriceGreaterThan(BigDecimal value) {
            addCriterion("user_discount_price >", value, "userDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andUserDiscountPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("user_discount_price >=", value, "userDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andUserDiscountPriceLessThan(BigDecimal value) {
            addCriterion("user_discount_price <", value, "userDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andUserDiscountPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("user_discount_price <=", value, "userDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andUserDiscountPriceIn(List<BigDecimal> values) {
            addCriterion("user_discount_price in", values, "userDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andUserDiscountPriceNotIn(List<BigDecimal> values) {
            addCriterion("user_discount_price not in", values, "userDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andUserDiscountPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("user_discount_price between", value1, value2, "userDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andUserDiscountPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("user_discount_price not between", value1, value2, "userDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andUserDiscountActualPriceIsNull() {
            addCriterion("user_discount_actual_price is null");
            return (Criteria) this;
        }

        public Criteria andUserDiscountActualPriceIsNotNull() {
            addCriterion("user_discount_actual_price is not null");
            return (Criteria) this;
        }

        public Criteria andUserDiscountActualPriceEqualTo(BigDecimal value) {
            addCriterion("user_discount_actual_price =", value, "userDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andUserDiscountActualPriceNotEqualTo(BigDecimal value) {
            addCriterion("user_discount_actual_price <>", value, "userDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andUserDiscountActualPriceGreaterThan(BigDecimal value) {
            addCriterion("user_discount_actual_price >", value, "userDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andUserDiscountActualPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("user_discount_actual_price >=", value, "userDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andUserDiscountActualPriceLessThan(BigDecimal value) {
            addCriterion("user_discount_actual_price <", value, "userDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andUserDiscountActualPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("user_discount_actual_price <=", value, "userDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andUserDiscountActualPriceIn(List<BigDecimal> values) {
            addCriterion("user_discount_actual_price in", values, "userDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andUserDiscountActualPriceNotIn(List<BigDecimal> values) {
            addCriterion("user_discount_actual_price not in", values, "userDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andUserDiscountActualPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("user_discount_actual_price between", value1, value2, "userDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andUserDiscountActualPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("user_discount_actual_price not between", value1, value2, "userDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andTradeActualAmountIsNull() {
            addCriterion("trade_actual_amount is null");
            return (Criteria) this;
        }

        public Criteria andTradeActualAmountIsNotNull() {
            addCriterion("trade_actual_amount is not null");
            return (Criteria) this;
        }

        public Criteria andTradeActualAmountEqualTo(BigDecimal value) {
            addCriterion("trade_actual_amount =", value, "tradeActualAmount");
            return (Criteria) this;
        }

        public Criteria andTradeActualAmountNotEqualTo(BigDecimal value) {
            addCriterion("trade_actual_amount <>", value, "tradeActualAmount");
            return (Criteria) this;
        }

        public Criteria andTradeActualAmountGreaterThan(BigDecimal value) {
            addCriterion("trade_actual_amount >", value, "tradeActualAmount");
            return (Criteria) this;
        }

        public Criteria andTradeActualAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("trade_actual_amount >=", value, "tradeActualAmount");
            return (Criteria) this;
        }

        public Criteria andTradeActualAmountLessThan(BigDecimal value) {
            addCriterion("trade_actual_amount <", value, "tradeActualAmount");
            return (Criteria) this;
        }

        public Criteria andTradeActualAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("trade_actual_amount <=", value, "tradeActualAmount");
            return (Criteria) this;
        }

        public Criteria andTradeActualAmountIn(List<BigDecimal> values) {
            addCriterion("trade_actual_amount in", values, "tradeActualAmount");
            return (Criteria) this;
        }

        public Criteria andTradeActualAmountNotIn(List<BigDecimal> values) {
            addCriterion("trade_actual_amount not in", values, "tradeActualAmount");
            return (Criteria) this;
        }

        public Criteria andTradeActualAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("trade_actual_amount between", value1, value2, "tradeActualAmount");
            return (Criteria) this;
        }

        public Criteria andTradeActualAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("trade_actual_amount not between", value1, value2, "tradeActualAmount");
            return (Criteria) this;
        }

        public Criteria andIncomeAmoutIsNull() {
            addCriterion("income_amout is null");
            return (Criteria) this;
        }

        public Criteria andIncomeAmoutIsNotNull() {
            addCriterion("income_amout is not null");
            return (Criteria) this;
        }

        public Criteria andIncomeAmoutEqualTo(BigDecimal value) {
            addCriterion("income_amout =", value, "incomeAmout");
            return (Criteria) this;
        }

        public Criteria andIncomeAmoutNotEqualTo(BigDecimal value) {
            addCriterion("income_amout <>", value, "incomeAmout");
            return (Criteria) this;
        }

        public Criteria andIncomeAmoutGreaterThan(BigDecimal value) {
            addCriterion("income_amout >", value, "incomeAmout");
            return (Criteria) this;
        }

        public Criteria andIncomeAmoutGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("income_amout >=", value, "incomeAmout");
            return (Criteria) this;
        }

        public Criteria andIncomeAmoutLessThan(BigDecimal value) {
            addCriterion("income_amout <", value, "incomeAmout");
            return (Criteria) this;
        }

        public Criteria andIncomeAmoutLessThanOrEqualTo(BigDecimal value) {
            addCriterion("income_amout <=", value, "incomeAmout");
            return (Criteria) this;
        }

        public Criteria andIncomeAmoutIn(List<BigDecimal> values) {
            addCriterion("income_amout in", values, "incomeAmout");
            return (Criteria) this;
        }

        public Criteria andIncomeAmoutNotIn(List<BigDecimal> values) {
            addCriterion("income_amout not in", values, "incomeAmout");
            return (Criteria) this;
        }

        public Criteria andIncomeAmoutBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("income_amout between", value1, value2, "incomeAmout");
            return (Criteria) this;
        }

        public Criteria andIncomeAmoutNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("income_amout not between", value1, value2, "incomeAmout");
            return (Criteria) this;
        }

        public Criteria andAccTradeNoIsNull() {
            addCriterion("acc_trade_no is null");
            return (Criteria) this;
        }

        public Criteria andAccTradeNoIsNotNull() {
            addCriterion("acc_trade_no is not null");
            return (Criteria) this;
        }

        public Criteria andAccTradeNoEqualTo(String value) {
            addCriterion("acc_trade_no =", value, "accTradeNo");
            return (Criteria) this;
        }

        public Criteria andAccTradeNoNotEqualTo(String value) {
            addCriterion("acc_trade_no <>", value, "accTradeNo");
            return (Criteria) this;
        }

        public Criteria andAccTradeNoGreaterThan(String value) {
            addCriterion("acc_trade_no >", value, "accTradeNo");
            return (Criteria) this;
        }

        public Criteria andAccTradeNoGreaterThanOrEqualTo(String value) {
            addCriterion("acc_trade_no >=", value, "accTradeNo");
            return (Criteria) this;
        }

        public Criteria andAccTradeNoLessThan(String value) {
            addCriterion("acc_trade_no <", value, "accTradeNo");
            return (Criteria) this;
        }

        public Criteria andAccTradeNoLessThanOrEqualTo(String value) {
            addCriterion("acc_trade_no <=", value, "accTradeNo");
            return (Criteria) this;
        }

        public Criteria andAccTradeNoLike(String value) {
            addCriterion("acc_trade_no like", value, "accTradeNo");
            return (Criteria) this;
        }

        public Criteria andAccTradeNoNotLike(String value) {
            addCriterion("acc_trade_no not like", value, "accTradeNo");
            return (Criteria) this;
        }

        public Criteria andAccTradeNoIn(List<String> values) {
            addCriterion("acc_trade_no in", values, "accTradeNo");
            return (Criteria) this;
        }

        public Criteria andAccTradeNoNotIn(List<String> values) {
            addCriterion("acc_trade_no not in", values, "accTradeNo");
            return (Criteria) this;
        }

        public Criteria andAccTradeNoBetween(String value1, String value2) {
            addCriterion("acc_trade_no between", value1, value2, "accTradeNo");
            return (Criteria) this;
        }

        public Criteria andAccTradeNoNotBetween(String value1, String value2) {
            addCriterion("acc_trade_no not between", value1, value2, "accTradeNo");
            return (Criteria) this;
        }

        public Criteria andAccMdiscountAmountIsNull() {
            addCriterion("acc_mdiscount_amount is null");
            return (Criteria) this;
        }

        public Criteria andAccMdiscountAmountIsNotNull() {
            addCriterion("acc_mdiscount_amount is not null");
            return (Criteria) this;
        }

        public Criteria andAccMdiscountAmountEqualTo(BigDecimal value) {
            addCriterion("acc_mdiscount_amount =", value, "accMdiscountAmount");
            return (Criteria) this;
        }

        public Criteria andAccMdiscountAmountNotEqualTo(BigDecimal value) {
            addCriterion("acc_mdiscount_amount <>", value, "accMdiscountAmount");
            return (Criteria) this;
        }

        public Criteria andAccMdiscountAmountGreaterThan(BigDecimal value) {
            addCriterion("acc_mdiscount_amount >", value, "accMdiscountAmount");
            return (Criteria) this;
        }

        public Criteria andAccMdiscountAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("acc_mdiscount_amount >=", value, "accMdiscountAmount");
            return (Criteria) this;
        }

        public Criteria andAccMdiscountAmountLessThan(BigDecimal value) {
            addCriterion("acc_mdiscount_amount <", value, "accMdiscountAmount");
            return (Criteria) this;
        }

        public Criteria andAccMdiscountAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("acc_mdiscount_amount <=", value, "accMdiscountAmount");
            return (Criteria) this;
        }

        public Criteria andAccMdiscountAmountIn(List<BigDecimal> values) {
            addCriterion("acc_mdiscount_amount in", values, "accMdiscountAmount");
            return (Criteria) this;
        }

        public Criteria andAccMdiscountAmountNotIn(List<BigDecimal> values) {
            addCriterion("acc_mdiscount_amount not in", values, "accMdiscountAmount");
            return (Criteria) this;
        }

        public Criteria andAccMdiscountAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("acc_mdiscount_amount between", value1, value2, "accMdiscountAmount");
            return (Criteria) this;
        }

        public Criteria andAccMdiscountAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("acc_mdiscount_amount not between", value1, value2, "accMdiscountAmount");
            return (Criteria) this;
        }

        public Criteria andAccDiscountAmountIsNull() {
            addCriterion("acc_discount_amount is null");
            return (Criteria) this;
        }

        public Criteria andAccDiscountAmountIsNotNull() {
            addCriterion("acc_discount_amount is not null");
            return (Criteria) this;
        }

        public Criteria andAccDiscountAmountEqualTo(BigDecimal value) {
            addCriterion("acc_discount_amount =", value, "accDiscountAmount");
            return (Criteria) this;
        }

        public Criteria andAccDiscountAmountNotEqualTo(BigDecimal value) {
            addCriterion("acc_discount_amount <>", value, "accDiscountAmount");
            return (Criteria) this;
        }

        public Criteria andAccDiscountAmountGreaterThan(BigDecimal value) {
            addCriterion("acc_discount_amount >", value, "accDiscountAmount");
            return (Criteria) this;
        }

        public Criteria andAccDiscountAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("acc_discount_amount >=", value, "accDiscountAmount");
            return (Criteria) this;
        }

        public Criteria andAccDiscountAmountLessThan(BigDecimal value) {
            addCriterion("acc_discount_amount <", value, "accDiscountAmount");
            return (Criteria) this;
        }

        public Criteria andAccDiscountAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("acc_discount_amount <=", value, "accDiscountAmount");
            return (Criteria) this;
        }

        public Criteria andAccDiscountAmountIn(List<BigDecimal> values) {
            addCriterion("acc_discount_amount in", values, "accDiscountAmount");
            return (Criteria) this;
        }

        public Criteria andAccDiscountAmountNotIn(List<BigDecimal> values) {
            addCriterion("acc_discount_amount not in", values, "accDiscountAmount");
            return (Criteria) this;
        }

        public Criteria andAccDiscountAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("acc_discount_amount between", value1, value2, "accDiscountAmount");
            return (Criteria) this;
        }

        public Criteria andAccDiscountAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("acc_discount_amount not between", value1, value2, "accDiscountAmount");
            return (Criteria) this;
        }

        public Criteria andAccPaymentCodeIsNull() {
            addCriterion("acc_payment_code is null");
            return (Criteria) this;
        }

        public Criteria andAccPaymentCodeIsNotNull() {
            addCriterion("acc_payment_code is not null");
            return (Criteria) this;
        }

        public Criteria andAccPaymentCodeEqualTo(String value) {
            addCriterion("acc_payment_code =", value, "accPaymentCode");
            return (Criteria) this;
        }

        public Criteria andAccPaymentCodeNotEqualTo(String value) {
            addCriterion("acc_payment_code <>", value, "accPaymentCode");
            return (Criteria) this;
        }

        public Criteria andAccPaymentCodeGreaterThan(String value) {
            addCriterion("acc_payment_code >", value, "accPaymentCode");
            return (Criteria) this;
        }

        public Criteria andAccPaymentCodeGreaterThanOrEqualTo(String value) {
            addCriterion("acc_payment_code >=", value, "accPaymentCode");
            return (Criteria) this;
        }

        public Criteria andAccPaymentCodeLessThan(String value) {
            addCriterion("acc_payment_code <", value, "accPaymentCode");
            return (Criteria) this;
        }

        public Criteria andAccPaymentCodeLessThanOrEqualTo(String value) {
            addCriterion("acc_payment_code <=", value, "accPaymentCode");
            return (Criteria) this;
        }

        public Criteria andAccPaymentCodeLike(String value) {
            addCriterion("acc_payment_code like", value, "accPaymentCode");
            return (Criteria) this;
        }

        public Criteria andAccPaymentCodeNotLike(String value) {
            addCriterion("acc_payment_code not like", value, "accPaymentCode");
            return (Criteria) this;
        }

        public Criteria andAccPaymentCodeIn(List<String> values) {
            addCriterion("acc_payment_code in", values, "accPaymentCode");
            return (Criteria) this;
        }

        public Criteria andAccPaymentCodeNotIn(List<String> values) {
            addCriterion("acc_payment_code not in", values, "accPaymentCode");
            return (Criteria) this;
        }

        public Criteria andAccPaymentCodeBetween(String value1, String value2) {
            addCriterion("acc_payment_code between", value1, value2, "accPaymentCode");
            return (Criteria) this;
        }

        public Criteria andAccPaymentCodeNotBetween(String value1, String value2) {
            addCriterion("acc_payment_code not between", value1, value2, "accPaymentCode");
            return (Criteria) this;
        }

        public Criteria andCardTypeIsNull() {
            addCriterion("card_type is null");
            return (Criteria) this;
        }

        public Criteria andCardTypeIsNotNull() {
            addCriterion("card_type is not null");
            return (Criteria) this;
        }

        public Criteria andCardTypeEqualTo(String value) {
            addCriterion("card_type =", value, "cardType");
            return (Criteria) this;
        }

        public Criteria andCardTypeNotEqualTo(String value) {
            addCriterion("card_type <>", value, "cardType");
            return (Criteria) this;
        }

        public Criteria andCardTypeGreaterThan(String value) {
            addCriterion("card_type >", value, "cardType");
            return (Criteria) this;
        }

        public Criteria andCardTypeGreaterThanOrEqualTo(String value) {
            addCriterion("card_type >=", value, "cardType");
            return (Criteria) this;
        }

        public Criteria andCardTypeLessThan(String value) {
            addCriterion("card_type <", value, "cardType");
            return (Criteria) this;
        }

        public Criteria andCardTypeLessThanOrEqualTo(String value) {
            addCriterion("card_type <=", value, "cardType");
            return (Criteria) this;
        }

        public Criteria andCardTypeLike(String value) {
            addCriterion("card_type like", value, "cardType");
            return (Criteria) this;
        }

        public Criteria andCardTypeNotLike(String value) {
            addCriterion("card_type not like", value, "cardType");
            return (Criteria) this;
        }

        public Criteria andCardTypeIn(List<String> values) {
            addCriterion("card_type in", values, "cardType");
            return (Criteria) this;
        }

        public Criteria andCardTypeNotIn(List<String> values) {
            addCriterion("card_type not in", values, "cardType");
            return (Criteria) this;
        }

        public Criteria andCardTypeBetween(String value1, String value2) {
            addCriterion("card_type between", value1, value2, "cardType");
            return (Criteria) this;
        }

        public Criteria andCardTypeNotBetween(String value1, String value2) {
            addCriterion("card_type not between", value1, value2, "cardType");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("`status` is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("`status` is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("`status` =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("`status` <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("`status` >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("`status` >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("`status` <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("`status` <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("`status` in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("`status` not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("`status` between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("`status` not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andProfitSharingStatusIsNull() {
            addCriterion("profit_sharing_status is null");
            return (Criteria) this;
        }

        public Criteria andProfitSharingStatusIsNotNull() {
            addCriterion("profit_sharing_status is not null");
            return (Criteria) this;
        }

        public Criteria andProfitSharingStatusEqualTo(Boolean value) {
            addCriterion("profit_sharing_status =", value, "profitSharingStatus");
            return (Criteria) this;
        }

        public Criteria andProfitSharingStatusNotEqualTo(Boolean value) {
            addCriterion("profit_sharing_status <>", value, "profitSharingStatus");
            return (Criteria) this;
        }

        public Criteria andProfitSharingStatusGreaterThan(Boolean value) {
            addCriterion("profit_sharing_status >", value, "profitSharingStatus");
            return (Criteria) this;
        }

        public Criteria andProfitSharingStatusGreaterThanOrEqualTo(Boolean value) {
            addCriterion("profit_sharing_status >=", value, "profitSharingStatus");
            return (Criteria) this;
        }

        public Criteria andProfitSharingStatusLessThan(Boolean value) {
            addCriterion("profit_sharing_status <", value, "profitSharingStatus");
            return (Criteria) this;
        }

        public Criteria andProfitSharingStatusLessThanOrEqualTo(Boolean value) {
            addCriterion("profit_sharing_status <=", value, "profitSharingStatus");
            return (Criteria) this;
        }

        public Criteria andProfitSharingStatusIn(List<Boolean> values) {
            addCriterion("profit_sharing_status in", values, "profitSharingStatus");
            return (Criteria) this;
        }

        public Criteria andProfitSharingStatusNotIn(List<Boolean> values) {
            addCriterion("profit_sharing_status not in", values, "profitSharingStatus");
            return (Criteria) this;
        }

        public Criteria andProfitSharingStatusBetween(Boolean value1, Boolean value2) {
            addCriterion("profit_sharing_status between", value1, value2, "profitSharingStatus");
            return (Criteria) this;
        }

        public Criteria andProfitSharingStatusNotBetween(Boolean value1, Boolean value2) {
            addCriterion("profit_sharing_status not between", value1, value2, "profitSharingStatus");
            return (Criteria) this;
        }

        public Criteria andPayTimeIsNull() {
            addCriterion("pay_time is null");
            return (Criteria) this;
        }

        public Criteria andPayTimeIsNotNull() {
            addCriterion("pay_time is not null");
            return (Criteria) this;
        }

        public Criteria andPayTimeEqualTo(Date value) {
            addCriterion("pay_time =", value, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeNotEqualTo(Date value) {
            addCriterion("pay_time <>", value, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeGreaterThan(Date value) {
            addCriterion("pay_time >", value, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("pay_time >=", value, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeLessThan(Date value) {
            addCriterion("pay_time <", value, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeLessThanOrEqualTo(Date value) {
            addCriterion("pay_time <=", value, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeIn(List<Date> values) {
            addCriterion("pay_time in", values, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeNotIn(List<Date> values) {
            addCriterion("pay_time not in", values, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeBetween(Date value1, Date value2) {
            addCriterion("pay_time between", value1, value2, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeNotBetween(Date value1, Date value2) {
            addCriterion("pay_time not between", value1, value2, "payTime");
            return (Criteria) this;
        }

        public Criteria andTimeoutExpressIsNull() {
            addCriterion("timeout_express is null");
            return (Criteria) this;
        }

        public Criteria andTimeoutExpressIsNotNull() {
            addCriterion("timeout_express is not null");
            return (Criteria) this;
        }

        public Criteria andTimeoutExpressEqualTo(Integer value) {
            addCriterion("timeout_express =", value, "timeoutExpress");
            return (Criteria) this;
        }

        public Criteria andTimeoutExpressNotEqualTo(Integer value) {
            addCriterion("timeout_express <>", value, "timeoutExpress");
            return (Criteria) this;
        }

        public Criteria andTimeoutExpressGreaterThan(Integer value) {
            addCriterion("timeout_express >", value, "timeoutExpress");
            return (Criteria) this;
        }

        public Criteria andTimeoutExpressGreaterThanOrEqualTo(Integer value) {
            addCriterion("timeout_express >=", value, "timeoutExpress");
            return (Criteria) this;
        }

        public Criteria andTimeoutExpressLessThan(Integer value) {
            addCriterion("timeout_express <", value, "timeoutExpress");
            return (Criteria) this;
        }

        public Criteria andTimeoutExpressLessThanOrEqualTo(Integer value) {
            addCriterion("timeout_express <=", value, "timeoutExpress");
            return (Criteria) this;
        }

        public Criteria andTimeoutExpressIn(List<Integer> values) {
            addCriterion("timeout_express in", values, "timeoutExpress");
            return (Criteria) this;
        }

        public Criteria andTimeoutExpressNotIn(List<Integer> values) {
            addCriterion("timeout_express not in", values, "timeoutExpress");
            return (Criteria) this;
        }

        public Criteria andTimeoutExpressBetween(Integer value1, Integer value2) {
            addCriterion("timeout_express between", value1, value2, "timeoutExpress");
            return (Criteria) this;
        }

        public Criteria andTimeoutExpressNotBetween(Integer value1, Integer value2) {
            addCriterion("timeout_express not between", value1, value2, "timeoutExpress");
            return (Criteria) this;
        }

        public Criteria andSubjectIsNull() {
            addCriterion("subject is null");
            return (Criteria) this;
        }

        public Criteria andSubjectIsNotNull() {
            addCriterion("subject is not null");
            return (Criteria) this;
        }

        public Criteria andSubjectEqualTo(String value) {
            addCriterion("subject =", value, "subject");
            return (Criteria) this;
        }

        public Criteria andSubjectNotEqualTo(String value) {
            addCriterion("subject <>", value, "subject");
            return (Criteria) this;
        }

        public Criteria andSubjectGreaterThan(String value) {
            addCriterion("subject >", value, "subject");
            return (Criteria) this;
        }

        public Criteria andSubjectGreaterThanOrEqualTo(String value) {
            addCriterion("subject >=", value, "subject");
            return (Criteria) this;
        }

        public Criteria andSubjectLessThan(String value) {
            addCriterion("subject <", value, "subject");
            return (Criteria) this;
        }

        public Criteria andSubjectLessThanOrEqualTo(String value) {
            addCriterion("subject <=", value, "subject");
            return (Criteria) this;
        }

        public Criteria andSubjectLike(String value) {
            addCriterion("subject like", value, "subject");
            return (Criteria) this;
        }

        public Criteria andSubjectNotLike(String value) {
            addCriterion("subject not like", value, "subject");
            return (Criteria) this;
        }

        public Criteria andSubjectIn(List<String> values) {
            addCriterion("subject in", values, "subject");
            return (Criteria) this;
        }

        public Criteria andSubjectNotIn(List<String> values) {
            addCriterion("subject not in", values, "subject");
            return (Criteria) this;
        }

        public Criteria andSubjectBetween(String value1, String value2) {
            addCriterion("subject between", value1, value2, "subject");
            return (Criteria) this;
        }

        public Criteria andSubjectNotBetween(String value1, String value2) {
            addCriterion("subject not between", value1, value2, "subject");
            return (Criteria) this;
        }

        public Criteria andPayNotifyUrlIsNull() {
            addCriterion("pay_notify_url is null");
            return (Criteria) this;
        }

        public Criteria andPayNotifyUrlIsNotNull() {
            addCriterion("pay_notify_url is not null");
            return (Criteria) this;
        }

        public Criteria andPayNotifyUrlEqualTo(String value) {
            addCriterion("pay_notify_url =", value, "payNotifyUrl");
            return (Criteria) this;
        }

        public Criteria andPayNotifyUrlNotEqualTo(String value) {
            addCriterion("pay_notify_url <>", value, "payNotifyUrl");
            return (Criteria) this;
        }

        public Criteria andPayNotifyUrlGreaterThan(String value) {
            addCriterion("pay_notify_url >", value, "payNotifyUrl");
            return (Criteria) this;
        }

        public Criteria andPayNotifyUrlGreaterThanOrEqualTo(String value) {
            addCriterion("pay_notify_url >=", value, "payNotifyUrl");
            return (Criteria) this;
        }

        public Criteria andPayNotifyUrlLessThan(String value) {
            addCriterion("pay_notify_url <", value, "payNotifyUrl");
            return (Criteria) this;
        }

        public Criteria andPayNotifyUrlLessThanOrEqualTo(String value) {
            addCriterion("pay_notify_url <=", value, "payNotifyUrl");
            return (Criteria) this;
        }

        public Criteria andPayNotifyUrlLike(String value) {
            addCriterion("pay_notify_url like", value, "payNotifyUrl");
            return (Criteria) this;
        }

        public Criteria andPayNotifyUrlNotLike(String value) {
            addCriterion("pay_notify_url not like", value, "payNotifyUrl");
            return (Criteria) this;
        }

        public Criteria andPayNotifyUrlIn(List<String> values) {
            addCriterion("pay_notify_url in", values, "payNotifyUrl");
            return (Criteria) this;
        }

        public Criteria andPayNotifyUrlNotIn(List<String> values) {
            addCriterion("pay_notify_url not in", values, "payNotifyUrl");
            return (Criteria) this;
        }

        public Criteria andPayNotifyUrlBetween(String value1, String value2) {
            addCriterion("pay_notify_url between", value1, value2, "payNotifyUrl");
            return (Criteria) this;
        }

        public Criteria andPayNotifyUrlNotBetween(String value1, String value2) {
            addCriterion("pay_notify_url not between", value1, value2, "payNotifyUrl");
            return (Criteria) this;
        }

        public Criteria andShdFeeAmtIsNull() {
            addCriterion("shd_fee_amt is null");
            return (Criteria) this;
        }

        public Criteria andShdFeeAmtIsNotNull() {
            addCriterion("shd_fee_amt is not null");
            return (Criteria) this;
        }

        public Criteria andShdFeeAmtEqualTo(BigDecimal value) {
            addCriterion("shd_fee_amt =", value, "shdFeeAmt");
            return (Criteria) this;
        }

        public Criteria andShdFeeAmtNotEqualTo(BigDecimal value) {
            addCriterion("shd_fee_amt <>", value, "shdFeeAmt");
            return (Criteria) this;
        }

        public Criteria andShdFeeAmtGreaterThan(BigDecimal value) {
            addCriterion("shd_fee_amt >", value, "shdFeeAmt");
            return (Criteria) this;
        }

        public Criteria andShdFeeAmtGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("shd_fee_amt >=", value, "shdFeeAmt");
            return (Criteria) this;
        }

        public Criteria andShdFeeAmtLessThan(BigDecimal value) {
            addCriterion("shd_fee_amt <", value, "shdFeeAmt");
            return (Criteria) this;
        }

        public Criteria andShdFeeAmtLessThanOrEqualTo(BigDecimal value) {
            addCriterion("shd_fee_amt <=", value, "shdFeeAmt");
            return (Criteria) this;
        }

        public Criteria andShdFeeAmtIn(List<BigDecimal> values) {
            addCriterion("shd_fee_amt in", values, "shdFeeAmt");
            return (Criteria) this;
        }

        public Criteria andShdFeeAmtNotIn(List<BigDecimal> values) {
            addCriterion("shd_fee_amt not in", values, "shdFeeAmt");
            return (Criteria) this;
        }

        public Criteria andShdFeeAmtBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("shd_fee_amt between", value1, value2, "shdFeeAmt");
            return (Criteria) this;
        }

        public Criteria andShdFeeAmtNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("shd_fee_amt not between", value1, value2, "shdFeeAmt");
            return (Criteria) this;
        }

        public Criteria andFeeRateIsNull() {
            addCriterion("fee_rate is null");
            return (Criteria) this;
        }

        public Criteria andFeeRateIsNotNull() {
            addCriterion("fee_rate is not null");
            return (Criteria) this;
        }

        public Criteria andFeeRateEqualTo(BigDecimal value) {
            addCriterion("fee_rate =", value, "feeRate");
            return (Criteria) this;
        }

        public Criteria andFeeRateNotEqualTo(BigDecimal value) {
            addCriterion("fee_rate <>", value, "feeRate");
            return (Criteria) this;
        }

        public Criteria andFeeRateGreaterThan(BigDecimal value) {
            addCriterion("fee_rate >", value, "feeRate");
            return (Criteria) this;
        }

        public Criteria andFeeRateGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("fee_rate >=", value, "feeRate");
            return (Criteria) this;
        }

        public Criteria andFeeRateLessThan(BigDecimal value) {
            addCriterion("fee_rate <", value, "feeRate");
            return (Criteria) this;
        }

        public Criteria andFeeRateLessThanOrEqualTo(BigDecimal value) {
            addCriterion("fee_rate <=", value, "feeRate");
            return (Criteria) this;
        }

        public Criteria andFeeRateIn(List<BigDecimal> values) {
            addCriterion("fee_rate in", values, "feeRate");
            return (Criteria) this;
        }

        public Criteria andFeeRateNotIn(List<BigDecimal> values) {
            addCriterion("fee_rate not in", values, "feeRate");
            return (Criteria) this;
        }

        public Criteria andFeeRateBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("fee_rate between", value1, value2, "feeRate");
            return (Criteria) this;
        }

        public Criteria andFeeRateNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("fee_rate not between", value1, value2, "feeRate");
            return (Criteria) this;
        }

        public Criteria andAttachIsNull() {
            addCriterion("attach is null");
            return (Criteria) this;
        }

        public Criteria andAttachIsNotNull() {
            addCriterion("attach is not null");
            return (Criteria) this;
        }

        public Criteria andAttachEqualTo(String value) {
            addCriterion("attach =", value, "attach");
            return (Criteria) this;
        }

        public Criteria andAttachNotEqualTo(String value) {
            addCriterion("attach <>", value, "attach");
            return (Criteria) this;
        }

        public Criteria andAttachGreaterThan(String value) {
            addCriterion("attach >", value, "attach");
            return (Criteria) this;
        }

        public Criteria andAttachGreaterThanOrEqualTo(String value) {
            addCriterion("attach >=", value, "attach");
            return (Criteria) this;
        }

        public Criteria andAttachLessThan(String value) {
            addCriterion("attach <", value, "attach");
            return (Criteria) this;
        }

        public Criteria andAttachLessThanOrEqualTo(String value) {
            addCriterion("attach <=", value, "attach");
            return (Criteria) this;
        }

        public Criteria andAttachLike(String value) {
            addCriterion("attach like", value, "attach");
            return (Criteria) this;
        }

        public Criteria andAttachNotLike(String value) {
            addCriterion("attach not like", value, "attach");
            return (Criteria) this;
        }

        public Criteria andAttachIn(List<String> values) {
            addCriterion("attach in", values, "attach");
            return (Criteria) this;
        }

        public Criteria andAttachNotIn(List<String> values) {
            addCriterion("attach not in", values, "attach");
            return (Criteria) this;
        }

        public Criteria andAttachBetween(String value1, String value2) {
            addCriterion("attach between", value1, value2, "attach");
            return (Criteria) this;
        }

        public Criteria andAttachNotBetween(String value1, String value2) {
            addCriterion("attach not between", value1, value2, "attach");
            return (Criteria) this;
        }

        public Criteria andRefundTypeIsNull() {
            addCriterion("refund_type is null");
            return (Criteria) this;
        }

        public Criteria andRefundTypeIsNotNull() {
            addCriterion("refund_type is not null");
            return (Criteria) this;
        }

        public Criteria andRefundTypeEqualTo(Integer value) {
            addCriterion("refund_type =", value, "refundType");
            return (Criteria) this;
        }

        public Criteria andRefundTypeNotEqualTo(Integer value) {
            addCriterion("refund_type <>", value, "refundType");
            return (Criteria) this;
        }

        public Criteria andRefundTypeGreaterThan(Integer value) {
            addCriterion("refund_type >", value, "refundType");
            return (Criteria) this;
        }

        public Criteria andRefundTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("refund_type >=", value, "refundType");
            return (Criteria) this;
        }

        public Criteria andRefundTypeLessThan(Integer value) {
            addCriterion("refund_type <", value, "refundType");
            return (Criteria) this;
        }

        public Criteria andRefundTypeLessThanOrEqualTo(Integer value) {
            addCriterion("refund_type <=", value, "refundType");
            return (Criteria) this;
        }

        public Criteria andRefundTypeIn(List<Integer> values) {
            addCriterion("refund_type in", values, "refundType");
            return (Criteria) this;
        }

        public Criteria andRefundTypeNotIn(List<Integer> values) {
            addCriterion("refund_type not in", values, "refundType");
            return (Criteria) this;
        }

        public Criteria andRefundTypeBetween(Integer value1, Integer value2) {
            addCriterion("refund_type between", value1, value2, "refundType");
            return (Criteria) this;
        }

        public Criteria andRefundTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("refund_type not between", value1, value2, "refundType");
            return (Criteria) this;
        }

        public Criteria andRefundPriceIsNull() {
            addCriterion("refund_price is null");
            return (Criteria) this;
        }

        public Criteria andRefundPriceIsNotNull() {
            addCriterion("refund_price is not null");
            return (Criteria) this;
        }

        public Criteria andRefundPriceEqualTo(BigDecimal value) {
            addCriterion("refund_price =", value, "refundPrice");
            return (Criteria) this;
        }

        public Criteria andRefundPriceNotEqualTo(BigDecimal value) {
            addCriterion("refund_price <>", value, "refundPrice");
            return (Criteria) this;
        }

        public Criteria andRefundPriceGreaterThan(BigDecimal value) {
            addCriterion("refund_price >", value, "refundPrice");
            return (Criteria) this;
        }

        public Criteria andRefundPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("refund_price >=", value, "refundPrice");
            return (Criteria) this;
        }

        public Criteria andRefundPriceLessThan(BigDecimal value) {
            addCriterion("refund_price <", value, "refundPrice");
            return (Criteria) this;
        }

        public Criteria andRefundPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("refund_price <=", value, "refundPrice");
            return (Criteria) this;
        }

        public Criteria andRefundPriceIn(List<BigDecimal> values) {
            addCriterion("refund_price in", values, "refundPrice");
            return (Criteria) this;
        }

        public Criteria andRefundPriceNotIn(List<BigDecimal> values) {
            addCriterion("refund_price not in", values, "refundPrice");
            return (Criteria) this;
        }

        public Criteria andRefundPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("refund_price between", value1, value2, "refundPrice");
            return (Criteria) this;
        }

        public Criteria andRefundPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("refund_price not between", value1, value2, "refundPrice");
            return (Criteria) this;
        }

        public Criteria andCreateTypeIsNull() {
            addCriterion("create_type is null");
            return (Criteria) this;
        }

        public Criteria andCreateTypeIsNotNull() {
            addCriterion("create_type is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTypeEqualTo(Integer value) {
            addCriterion("create_type =", value, "createType");
            return (Criteria) this;
        }

        public Criteria andCreateTypeNotEqualTo(Integer value) {
            addCriterion("create_type <>", value, "createType");
            return (Criteria) this;
        }

        public Criteria andCreateTypeGreaterThan(Integer value) {
            addCriterion("create_type >", value, "createType");
            return (Criteria) this;
        }

        public Criteria andCreateTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("create_type >=", value, "createType");
            return (Criteria) this;
        }

        public Criteria andCreateTypeLessThan(Integer value) {
            addCriterion("create_type <", value, "createType");
            return (Criteria) this;
        }

        public Criteria andCreateTypeLessThanOrEqualTo(Integer value) {
            addCriterion("create_type <=", value, "createType");
            return (Criteria) this;
        }

        public Criteria andCreateTypeIn(List<Integer> values) {
            addCriterion("create_type in", values, "createType");
            return (Criteria) this;
        }

        public Criteria andCreateTypeNotIn(List<Integer> values) {
            addCriterion("create_type not in", values, "createType");
            return (Criteria) this;
        }

        public Criteria andCreateTypeBetween(Integer value1, Integer value2) {
            addCriterion("create_type between", value1, value2, "createType");
            return (Criteria) this;
        }

        public Criteria andCreateTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("create_type not between", value1, value2, "createType");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeIsNull() {
            addCriterion("cancel_time is null");
            return (Criteria) this;
        }

        public Criteria andCancelTimeIsNotNull() {
            addCriterion("cancel_time is not null");
            return (Criteria) this;
        }

        public Criteria andCancelTimeEqualTo(Date value) {
            addCriterion("cancel_time =", value, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeNotEqualTo(Date value) {
            addCriterion("cancel_time <>", value, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeGreaterThan(Date value) {
            addCriterion("cancel_time >", value, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("cancel_time >=", value, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeLessThan(Date value) {
            addCriterion("cancel_time <", value, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeLessThanOrEqualTo(Date value) {
            addCriterion("cancel_time <=", value, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeIn(List<Date> values) {
            addCriterion("cancel_time in", values, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeNotIn(List<Date> values) {
            addCriterion("cancel_time not in", values, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeBetween(Date value1, Date value2) {
            addCriterion("cancel_time between", value1, value2, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeNotBetween(Date value1, Date value2) {
            addCriterion("cancel_time not between", value1, value2, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}