package com.hfkj.service;

import com.hfkj.entity.BsDevicePrice;
import com.hfkj.sysenum.DevicePriceTypeEnum;
import com.hfkj.sysenum.DeviceTypeEnum;

import java.math.BigDecimal;

/**
 * @className: BsDevicePriceService
 * @author: HuRui
 * @date: 2022/12/29
 **/
public interface BsDevicePriceService {

    /**
     * 根据设备类型查询
     * @param deviceType
     * @return
     */
    BigDecimal getPriceByType(DevicePriceTypeEnum devicePriceType, DeviceTypeEnum deviceType);

}
