package com.hfkj.dao;

import com.hfkj.entity.BsMerContractRecordMsg;
import com.hfkj.entity.BsMerContractRecordMsgExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsMerContractRecordMsgMapper extends BsMerContractRecordMsgMapperExt {
    @SelectProvider(type=BsMerContractRecordMsgSqlProvider.class, method="countByExample")
    long countByExample(BsMerContractRecordMsgExample example);

    @DeleteProvider(type=BsMerContractRecordMsgSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsMerContractRecordMsgExample example);

    @Delete({
        "delete from bs_mer_contract_record_msg",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_mer_contract_record_msg (order_no, `type`, ",
        "request_content, response_code, ",
        "response_msg, response_content, ",
        "create_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{orderNo,jdbcType=VARCHAR}, #{type,jdbcType=INTEGER}, ",
        "#{requestContent,jdbcType=VARCHAR}, #{responseCode,jdbcType=VARCHAR}, ",
        "#{responseMsg,jdbcType=VARCHAR}, #{responseContent,jdbcType=VARCHAR}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsMerContractRecordMsg record);

    @InsertProvider(type=BsMerContractRecordMsgSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsMerContractRecordMsg record);

    @SelectProvider(type=BsMerContractRecordMsgSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="order_no", property="orderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="request_content", property="requestContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="response_code", property="responseCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="response_msg", property="responseMsg", jdbcType=JdbcType.VARCHAR),
        @Result(column="response_content", property="responseContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsMerContractRecordMsg> selectByExample(BsMerContractRecordMsgExample example);

    @Select({
        "select",
        "id, order_no, `type`, request_content, response_code, response_msg, response_content, ",
        "create_time, ext_1, ext_2, ext_3",
        "from bs_mer_contract_record_msg",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="order_no", property="orderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="request_content", property="requestContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="response_code", property="responseCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="response_msg", property="responseMsg", jdbcType=JdbcType.VARCHAR),
        @Result(column="response_content", property="responseContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsMerContractRecordMsg selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsMerContractRecordMsgSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsMerContractRecordMsg record, @Param("example") BsMerContractRecordMsgExample example);

    @UpdateProvider(type=BsMerContractRecordMsgSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsMerContractRecordMsg record, @Param("example") BsMerContractRecordMsgExample example);

    @UpdateProvider(type=BsMerContractRecordMsgSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsMerContractRecordMsg record);

    @Update({
        "update bs_mer_contract_record_msg",
        "set order_no = #{orderNo,jdbcType=VARCHAR},",
          "`type` = #{type,jdbcType=INTEGER},",
          "request_content = #{requestContent,jdbcType=VARCHAR},",
          "response_code = #{responseCode,jdbcType=VARCHAR},",
          "response_msg = #{responseMsg,jdbcType=VARCHAR},",
          "response_content = #{responseContent,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsMerContractRecordMsg record);
}