package com.hfkj.dao;

import com.hfkj.entity.BsStoreDiscountActivityPartakeUserRecord;
import com.hfkj.entity.BsStoreDiscountActivityPartakeUserRecordExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsStoreDiscountActivityPartakeUserRecordMapper extends BsStoreDiscountActivityPartakeUserRecordMapperExt {
    @SelectProvider(type=BsStoreDiscountActivityPartakeUserRecordSqlProvider.class, method="countByExample")
    long countByExample(BsStoreDiscountActivityPartakeUserRecordExample example);

    @DeleteProvider(type=BsStoreDiscountActivityPartakeUserRecordSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsStoreDiscountActivityPartakeUserRecordExample example);

    @Delete({
        "delete from bs_store_discount_activity_partake_user_record",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_store_discount_activity_partake_user_record (discount_activity_id, discount_activity_name, ",
        "discount_type, discount_condition, ",
        "discount_price, user_phone, ",
        "create_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{discountActivityId,jdbcType=BIGINT}, #{discountActivityName,jdbcType=VARCHAR}, ",
        "#{discountType,jdbcType=INTEGER}, #{discountCondition,jdbcType=DECIMAL}, ",
        "#{discountPrice,jdbcType=DECIMAL}, #{userPhone,jdbcType=VARCHAR}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsStoreDiscountActivityPartakeUserRecord record);

    @InsertProvider(type=BsStoreDiscountActivityPartakeUserRecordSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsStoreDiscountActivityPartakeUserRecord record);

    @SelectProvider(type=BsStoreDiscountActivityPartakeUserRecordSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="discount_activity_id", property="discountActivityId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_activity_name", property="discountActivityName", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_type", property="discountType", jdbcType=JdbcType.INTEGER),
        @Result(column="discount_condition", property="discountCondition", jdbcType=JdbcType.DECIMAL),
        @Result(column="discount_price", property="discountPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="user_phone", property="userPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsStoreDiscountActivityPartakeUserRecord> selectByExample(BsStoreDiscountActivityPartakeUserRecordExample example);

    @Select({
        "select",
        "id, discount_activity_id, discount_activity_name, discount_type, discount_condition, ",
        "discount_price, user_phone, create_time, ext_1, ext_2, ext_3",
        "from bs_store_discount_activity_partake_user_record",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="discount_activity_id", property="discountActivityId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_activity_name", property="discountActivityName", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_type", property="discountType", jdbcType=JdbcType.INTEGER),
        @Result(column="discount_condition", property="discountCondition", jdbcType=JdbcType.DECIMAL),
        @Result(column="discount_price", property="discountPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="user_phone", property="userPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsStoreDiscountActivityPartakeUserRecord selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsStoreDiscountActivityPartakeUserRecordSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsStoreDiscountActivityPartakeUserRecord record, @Param("example") BsStoreDiscountActivityPartakeUserRecordExample example);

    @UpdateProvider(type=BsStoreDiscountActivityPartakeUserRecordSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsStoreDiscountActivityPartakeUserRecord record, @Param("example") BsStoreDiscountActivityPartakeUserRecordExample example);

    @UpdateProvider(type=BsStoreDiscountActivityPartakeUserRecordSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsStoreDiscountActivityPartakeUserRecord record);

    @Update({
        "update bs_store_discount_activity_partake_user_record",
        "set discount_activity_id = #{discountActivityId,jdbcType=BIGINT},",
          "discount_activity_name = #{discountActivityName,jdbcType=VARCHAR},",
          "discount_type = #{discountType,jdbcType=INTEGER},",
          "discount_condition = #{discountCondition,jdbcType=DECIMAL},",
          "discount_price = #{discountPrice,jdbcType=DECIMAL},",
          "user_phone = #{userPhone,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsStoreDiscountActivityPartakeUserRecord record);
}