package com.hfkj.openapi.v1.model.response;

import com.hfkj.entity.BsTradeOrderProfitSharing;
import com.hfkj.sysenum.ProfitSharingStatusEnum;
import lombok.Data;
import org.hibernate.validator.constraints.Length;

import javax.validation.Valid;
import javax.validation.constraints.DecimalMax;
import javax.validation.constraints.DecimalMin;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.util.List;

/**
 * 请求分账
 * @className: RequestSeparateModel
 * @author: HuRui
 * @date: 2023/5/26
 **/
@Data
public class ResponseSeparateModel {

    /**
     * 商户号
     */
    private String merchantNo;

    /**
     * 分账流水号
     */
    private String outSeparateNo;

    /**
     * 	分账系统生成唯一流水
     */
    private String separateNo;

    /**
     * 分账总金额
     */
    private String totalAmount;

    /**
     * 分账状态
     */
    private Integer status;

    /**
     * 签名参数
     */
    private String sign;

}
